!!! Image pertuatbation due to perturbed Q from ADCIG- Yi Shen, Jan 10, 2014
!!! input.H: input[Ang, Ath, mz, mx, my]
!!! dimg.x <input.H nwin=[] lwin=[] spex=spex.H rati=rati.H ftln=ftln.H slop=slop.H scal=scal.H fobj=fobj.H ngroup=1 nref=1 nsmth=1 slop_neg=1>output.H
! ! spex=spex[Ang, Ath, win, mx, my,freq].H 
! ! rati=rati[Ang, Ath, win, mx, my,freq].H 
! ! ftln=ftln[Ang, Ath, win, mx, my,freq].H 
! ! slop=slop[Ang, Ath, win, mx, my].H 
! ! scal=scal[Ang, Ath, win, mx, my].H 
! ! fobj=fobj[1].H
! ! ngroup=ng:sum ng points of spectra along x
! ! nref=1: compare spectra with the nref window
! ! nsmth=1: smooth slopsft along windows
! ! slop_neg=true: only consider the slope with negative value



program dimg_ADCIG
  use sep
  use util_axisIO
  use line
  use smallsolver
  use cgstep_mod
  use wei_myfft_mod
  use wei_hamming_mod

  implicit none

 
  integer			:: n1, n2, n3, n4, n5
  real				:: d1, d2, d3, d4, d5, o1, o2, o3, o4, o5
  integer			:: i1, i2, i3, i4, i5, iwin, ig, is1, is3
  real				:: dw,ow
  integer			:: ismth, nsmth
  integer			:: nw, stat
  integer			:: tbeg, tend,tend2
  logical			:: slop_neg
  integer			:: ng, nref
  integer			:: dwin, nwin, lwin, niter, nwin2
  real				:: fmin, fmax
  integer			:: nf, iif, ifmin
  type(myaxis)  		:: axis1,axis2,axis3,axis4,axis5,axis6,axis7,axis8,axis9
  complex, allocatable 		:: ctrace1(:),wtrace(:)
  complex, allocatable		:: fft1(:,:,:,:,:,:)
  real, allocatable		:: spex(:,:,:,:,:,:)
  real, allocatable		:: rati(:,:,:,:,:,:)
  real, allocatable		:: ftln(:,:,:,:,:,:)
  real, allocatable		:: slop(:,:,:,:,:),slopsft(:,:,:,:,:), scalsft(:,:,:,:,:)
  real, allocatable		:: scal(:,:,:,:,:)
  real, allocatable		:: d(:), m(:)
  real, allocatable 		:: data(:,:,:,:,:)
  real, allocatable		:: fobj(:)
  real, dimension (1) 		::endSgn



  call sep_init()


	
  call from_history ('n1',n1)
  call from_history ("d1",d1)
  call from_history ("o1",o1)

  call from_history ('n2', n2)
  call from_history ("d2", d2)
  call from_history ("o2", o2) 

  call from_history ('n3',n3)
  call from_history ("d3",d3)
  call from_history ("o3",o3)

  call from_history ('n4',n4)
  call from_history ("d4",d4)
  call from_history ("o4",o4)

  call from_history ('n5', n5)
  call from_history ("d5", d5)
  call from_history ("o5", o5) 

  ow=0.
  nw=n3;
  dw = 1./(n3*d3)
  call from_param("nwin",nwin,10)
  call from_param("lwin",lwin,n5/5)
  call from_param("fmin",fmin, ow)
  call from_param("fmax",fmax, (ow+(nw-1)*dw)/2.)
  call from_param("niter", niter,50)
  call from_param("ngroup", ng,1)
  call from_param("nref", nref,1)
  call from_param("nsmth", nsmth,1)
  call from_param("slop_neg", slop_neg,.true.)

  if(nwin==1) then
	dwin=0
  else
	  dwin=(n3-lwin*nwin)/(nwin-1)
  end if
  write(0,*)'dwin',dwin+lwin
  nwin2=n3/(lwin+dwin)
  nf=(fmax-fmin)/dw+1   !!! pick nf for least square

  allocate(ctrace1(n3), wtrace(nw),data(n1, n2, n3, n4, n5), fft1(n1, n2, nwin, n4, n5, nw))
  allocate(spex(n1 ,n2, nwin, n4, n5, nw),rati(n1 ,n2, nwin, n4, n5, nw), ftln(n1 ,n2, nwin, n4, n5, nw))
  allocate(slop(n1 ,n2, nwin, n4, n5),scal(n1 ,n2, nwin, n4, n5))
  allocate(scalsft(n1 ,n2 , n3, n4, n5), slopsft(n1 ,n2 , n3, n4, n5))
  allocate(m(2),d(nf))
  allocate(fobj(1))
  call sep_read(data)

!!!!!!!!!!!!  FFT
!???????????  no hamming window, nz=nw
!!! for Q analysis
  fft1=0.;
  do i5=1, n5
  do i4=1, n4
  do i2=1,n2
  do i1=1,n1
      do iwin=1,nwin

        
	tbeg=(iwin-1)*(lwin+dwin)+1
	tend=tbeg+lwin-1    

	if(tend .gt. n3 ) then
	  tend=n3
        end if
        ctrace1=0.;
        ctrace1(tbeg:tend)=data(i1, i2 ,tbeg:tend , i4, i5)
	call FFT1DX(ctrace1, 1)

        fft1(i1, i2, iwin, i4, i5, :) =ctrace1	

      end do

    end do
  end do
  end do 
  end do


!!!!!!!!!!!! spectral : group the traces or not
 spex=0.0
  do i1=1,n1

     do ig=1,ng
	if (i1+ig-1 .gt. n1) then
		exit
	else
    		 spex(i1, :, :, :, :, :)=spex(i1, :, :, :, :, :)+abs(fft1(i1+ig-1, :, :, :, :, :))
	end if
     end do
  end do
  end do

write(0,*) "FFT..."
!!!!!!!!!!!! spectral ratio  
!?????????? if (spex(i3,i4,iwin,i5) .lt. 1./1000.*rtmax) then rati(i3,i4,iwin,i5)=0.



  rati=0.

  do i5=1, n5
  do i4=1, n4
  do i2=1,n2

    do iwin=1,nwin
    do i3=1, nw
      ! reference window compare, by default nref=1
	 if (spex(nref, i2, iwin, i4, i5, i3) ==0.) then
		rati(:, i2, iwin, i4, i5, i3)=0.
         else
		do i1=1, n1
			if (spex(i1, i2, iwin, i4, i5, i3) ==0.) then
				rati(i1, i2, iwin, i4, i5, i3)=0.
			else		
				rati(i1, i2, iwin, i4, i5, i3) = log (spex(i1, i2, iwin, i4, i5, i3)/spex(nref, i2, iwin, i4, i5, i3))
			end if
		end do
	 end if

     end do
     end do

  end do
  end do
  end do
write(0,*) "Spectral ratio"

!!!!!!!!!!!!!!!!!! least square fitting

  d=0.; m=0.;
  slop=0.;scal=0.; ftln=0.



  do i5=1, n5
  do i4=1, n4
  do i2=1,n2

    do iwin=1, nwin
    slop(nref, i2, iwin, i4, i5)=0. 
    scal(nref, i2, iwin, i4, i5)=0.
    ftln(nref, i2, iwin, i4, i5,:)=0.
     do i1=1, n1
        do iif=1,nf
	  ifmin=(fmin-ow)/dw
  	  d(iif)=rati(i1, i2, iwin, i4, i5, ifmin+iif)

        end do

	call line_init(nf, fmin, dw)
        stat = line_lop( .true., .false., m, d)
	call solver(oper=line_lop, solv=cgstep, x=m,dat=d,niter=niter)
	slop(i1,i2,iwin,i4,i5)=m(1)
 	scal(i1,i2,iwin,i4,i5)=m(2)
	do i3=1,nw/2
		ftln(i1, i2, iwin, i4, i5, i3)=scal(i1, i2, iwin, i4,i5)+slop(i1, i2, iwin, i4,i5)*((i3-1)*dw+ow)
	end do
	
	!write(0,*) "scal, slop", scal(i3,i4,iwin),slop(i3,i4,iwin)
    end do

   end do

  end do 
  end do
  end do

write(0,*) "least square"


!  shift and smooth and eclip=0.0
	slopsft=0.
	fobj=0.
  do i5=1, n5
  do i4=1, n4
	do i2=1,n2
	do i1=ng/2,n1
	do i3=lwin/2,n3
		is1=i1-ng/2+1
		is3=(i3-lwin/2)/(lwin+dwin)+1
		do ismth=1,nsmth
			if (is3+ismth-1 .gt. nwin ) then
				exit
			else
				slopsft(i1, i2, i3, i4, i5)=slopsft(i1, i2, i3, i4, i5)+slop(is1,i2, is3+ismth-1, i4, i5)
				scalsft(i1, i2, i3, i4, i5)=scalsft(i1, i2, i3, i4, i5)+scal(is1,i2, is3+ismth-1, i4, i5)
			end if
		end do
	
		if ((slopsft(i1, i2, i3, i4, i5) .gt. 0.) .and. (slop_neg .ne. .false.)) then

			slopsft(i1, i2, i3, i4, i5) =0.
			scalsft(i1, i2, i3, i4, i5) =0.
		else
			slopsft(i1, i2, i3, i4, i5)=slopsft(i1, i2, i3, i4, i5)/nsmth
			scalsft(i1, i2, i3, i4, i5)=scalsft(i1, i2, i3, i4, i5)/nsmth

		end if

		fobj=fobj+(slopsft(i1, i2, i3, i4, i5)*slopsft(i1, i2, i3, i4, i5))/n1/n2/n3/n4/n5
	end do
	end do
	end do
  end do
  end do
write(0,*) "slope shift"





  call set_axis(axis1,n1,d1,o1+(ng)*d1/2.,"Ang")
  call set_axis(axis2,n2,d2,o2,"Athm")
  call set_axis(axis3,nwin,(lwin+dwin)*d3,o3+lwin/2.*d3,"win")
  call set_axis(axis4,n4,d4,o4,"mx")
  call set_axis(axis5,n5,d5,o5,"my")
  call set_axis(axis6,nw,dw,ow,"freq")
  call set_axis(axis7,n3,d3,o3,"z")
  call set_axis(axis8,1,1.,0.," ")
  call set_axis(axis9,n1,d1,o1,"Ang")




  allocate(spex(n1 ,n2, nwin, n4, n5, nw),rati(n1 ,n2, nwin, n4, n5, nw), ftln(n1 ,n2, nwin, n4, n5, nw))
  allocate(slop(n1 ,n2, nwin, n4, n5),scal(n1 ,n2, nwin, n4, n5))



  call houtaxis(axis1,1,'spex')
  call houtaxis(axis2,2,'spex')
  call houtaxis(axis3,3,'spex')
  call houtaxis(axis4,4,'spex')
  call houtaxis(axis5,5,'spex')
  call houtaxis(axis6,6,'spex')
  call houtaxis(axis8,7,'spex')

  call houtaxis(axis1,1,'rati')
  call houtaxis(axis2,2,'rati')
  call houtaxis(axis3,3,'rati')
  call houtaxis(axis4,4,'rati')
  call houtaxis(axis5,5,'rati')
  call houtaxis(axis6,6,'rati')
  call houtaxis(axis8,7,'rati')

  call houtaxis(axis1,1,'ftln')
  call houtaxis(axis2,2,'ftln')
  call houtaxis(axis3,3,'ftln')
  call houtaxis(axis4,4,'ftln')
  call houtaxis(axis5,5,'ftln')
  call houtaxis(axis6,6,'ftln')
  call houtaxis(axis8,7,'ftln')

  call houtaxis(axis1,1,'slop')
  call houtaxis(axis2,2,'slop')
  call houtaxis(axis3,3,'slop')
  call houtaxis(axis4,4,'slop')
  call houtaxis(axis5,5,'slop')

  call houtaxis(axis9,1,'slopsft')
  call houtaxis(axis2,2,'slopsft')
  call houtaxis(axis7,3,'slopsft')
  call houtaxis(axis4,4,'slopsft')
  call houtaxis(axis5,5,'slopsft')

  call houtaxis(axis9,1,'scal')
  call houtaxis(axis2,2,'scal')
  call houtaxis(axis7,3,'scal')
  call houtaxis(axis4,4,'scal')
  call houtaxis(axis5,5,'scal')

  call houtaxis(axis5,1,'fobj')

  call sep_write(spex,'spex')
  call sep_write(rati, 'rati')
  call sep_write(ftln, 'ftln')
  call sep_write(slop, 'slop')
  call sep_write(slopsft, 'slopsft')
  call sep_write(scal, 'scal')
  call sep_write(fobj, 'fobj')
  call sep_write(endSgn,'end')
  deallocate(ctrace1, wtrace, data, fft1)
  deallocate(spex,rati)
  deallocate(ftln,slop,scal,m,d,slopsft, scalsft)
  deallocate(fobj)
  call sep_close()
end program

