!!! Image pertuatbation due to perturbed Q from ADCIG- Yi Shen, Jan 10, 2014
!!! input.H: input[Ang, Ath, mz, mx, my]
!!! dimg_ADCIG.x <input.H nwin=[] lwin=[] spex_raw=spex_raw.H(unstretched) spex=spex.H rati=rati.H ftln=ftln.H slop=slop.H scal=scal.H fobj=fobj.H ngroup=1 nref=1 nsmth=1 slop_neg=1 mx=mx my=my nf=1>output.H
! ! spex=spex[Ang, Ath, win, freq].H at mx and my
! ! rati=rati[Ang, Ath, win, freq].H at mx and my
! ! ftln=ftln[Ang, Ath, win, freq].H at mx and my 
! ! slop=slop[Ang, Ath, win, mx, my].H 
! ! scal=scal[Ang, Ath, win, mx, my].H 
! ! fobj=fobj[1].H
! ! ngroup=ng:sum ng points of spectra along x
! ! nref=1: compare spectra with the nref window
! ! nsmth=1: smooth slopsft along windows
! ! slop_neg=true: only consider the slope with negative value
! ! mx, my: the spex, rati and ftln at [mx, my]
! ! nf: frequency range number for least square: middle point is the peak



program dimg_ADCIG
  use sep
  use util_axisIO
  use line
  use smallsolver
  use cgstep_mod
  use wei_myfft_mod
  use wei_hamming_mod

  implicit none

 
  integer			:: n1, n2, n3, n4, n5
  real				:: d1, d2, d3, d4, d5, o1, o2, o3, o4, o5
  integer			:: i1, i2, i3, i4, i5, iwin, ig, is1, is3
  real				:: dw,ow
  integer			:: ismth, nsmth
  integer			:: nw, stat
  integer			:: tbeg, tend
  logical			:: slop_neg
  integer			:: ng, nref
  integer			:: dwin, nwin, lwin, niter
  real				:: fmin, fmax
  integer			:: nf, iif, ifmin, if_min,if_peak
  type(myaxis)  		:: axis1,axis2,axis3,axis4,axis5,axis6,axis7,axis8,axis9
  complex, allocatable 		:: ctrace1(:),wtrace(:)
  complex, allocatable		:: fft1(:,:,:,:,:,:)
  real, allocatable		:: spex(:,:,:,:,:,:), spex_raw(:,:,:,:,:,:),spex2(:,:,:,:),spex2_raw(:,:,:,:)
  real, allocatable		:: rati(:,:,:,:,:,:), rati2(:,:,:,:)
  real, allocatable		:: ftln(:,:,:,:,:,:), ftln2(:,:,:,:)
  real, allocatable		:: slop(:,:,:,:,:),slopsft(:,:,:,:,:), scalsft(:,:,:,:,:)
  real, allocatable		:: scal(:,:,:,:,:)
  real, allocatable		:: d(:), m(:)
  real, allocatable 		:: data(:,:,:,:,:)
  real, allocatable		:: fobj(:)
  real, dimension (1) 		:: endSgn
  integer			:: mx, my
  logical			:: ref_max
  real				:: angle, corr
  real				:: loc
  real    			:: ll, wt
  integer 			:: ill,il
  integer			:: nref_n(1), if_peakn(1)



  call sep_init()


	
  call from_history ('n1',n1)
  call from_history ("d1",d1)
  call from_history ("o1",o1)

  call from_history ('n2', n2)
  call from_history ("d2", d2)
  call from_history ("o2", o2) 

  call from_history ('n3',n3)
  call from_history ("d3",d3)
  call from_history ("o3",o3)

  call from_history ('n4',n4)
  call from_history ("d4",d4)
  call from_history ("o4",o4)

  call from_history ('n5', n5)
  call from_history ("d5", d5)
  call from_history ("o5", o5) 

  ow=0.
  nw=n3;
  dw = 1./(n3*d3)
  call from_param("nwin",nwin,10)
  call from_param("lwin",lwin,n5/5)
  call from_param("fmin",fmin, ow)
  call from_param("fmax",fmax, (ow+(nw-1)*dw)/2.)
  call from_param("niter", niter,50)
  call from_param("ngroup", ng,1)
  call from_param("nref", nref,1)
  call from_param("nsmth", nsmth,1)
  call from_param("slop_neg", slop_neg,.true.)
  call from_param("mx", mx,1)
  call from_param("my", my,1)
  call from_param("ref_max", ref_max,.true.)
  call from_param("nf", nf,1)
  if(nwin==1) then
	dwin=0
  else
	  dwin=(n3-lwin*nwin)/(nwin-1)
  end if
  write(0,*)'dwin',dwin+lwin



  allocate(ctrace1(n3),wtrace(nw),data(n1, n2, n3, n4, n5), fft1(n1, n2, nwin, n4, n5, nw))
  allocate(spex(n1 ,n2, nwin, n4, n5, nw),rati(n1 ,n2, nwin, n4, n5, nw), ftln(n1 ,n2, nwin, n4, n5, nw), spex_raw(n1 ,n2, nwin, n4, n5, nw))
  allocate(spex2(n1 ,n2, nwin, nw),rati2(n1 ,n2, nwin, nw), ftln2(n1 ,n2, nwin, nw),spex2_raw(n1 ,n2, nwin, nw))
  allocate(slop(n1 ,n2, nwin, n4, n5),scal(n1 ,n2, nwin, n4, n5))
  allocate(scalsft(n1 ,n2 , n3, n4, n5), slopsft(n1 ,n2 , n3, n4, n5))
  allocate(m(2),d(nf))
  allocate(fobj(1))
  call sep_read(data)

!!!!!!!!!!!!  FFT
!???????????  no hamming window, nz=nw
!!! for Q analysis
  fft1=0.;
  do i5=1, n5
  do i4=1, n4
  do i2=1,n2
  do i1=1,n1
      do iwin=1,nwin

        
	tbeg=(iwin-1)*(lwin+dwin)+1
	tend=tbeg+lwin-1    

	if(tend .gt. n3 ) then
	  tend=n3
        end if
        ctrace1=0.;
        ctrace1(tbeg:tend)=data(i1, i2 ,tbeg:tend , i4, i5)
	call FFT1DX(ctrace1, 1)

        fft1(i1, i2, iwin, i4, i5, :) =ctrace1	

      end do

    end do
  end do
  end do 
  end do


!!!!!!!!!!!! spectral : group the traces or not
 spex=0.0
  do i1=1,n1
     do ig=1,ng
	if (i1+ig-1 .gt. n1) then
		exit
	else
    		 spex_raw(i1, :, :, :, :, :)=spex_raw(i1, :, :, :, :, :)+abs(fft1(i1+ig-1, :, :, :, :, :))
	end if
     end do
  end do



  do i5=1, n5
  do i4=1, n4
  do i2=1,n2
  do iwin=1,nwin

  do i1=1, n1   !!! loop over offset/angle
	angle=(d1*(i1-1)+o1)*3.14159265/180.
	corr=cos(angle)

	do i3=1, n3-1
		loc=(o3+(i3-1)*d3)*corr
		ll = (loc-o3)/d3
        	ill=ll
       		il=1+ill  
       		wt = ll-ill

		spex(i1, i2, iwin, i4, i5, i3)=spex_raw(i1, i2, iwin, i4, i5, il)*(1.-wt)+spex_raw(i1, i2, iwin, i4, i5, il+1)*wt
	end do
  end do

  end do
  end do
  end do
  end do

write(0,*) "FFT..."
!!!!!!!!!!!! spectral ratio  
!?????????? if (spex(i3,i4,iwin,i5) .lt. 1./1000.*rtmax) then rati(i3,i4,iwin,i5)=0.



  rati=0.
 ! nf=(fmax-fmin)/dw+1   !!! pick nf for least square
  
  do i5=1, n5
  do i4=1, n4
  do i2=1,n2

    do iwin=1,nwin
	!if (ref_max .ne. .False.) then
	!  nref_n=maxloc(spex(:, i2, iwin, i4, i5, i3))
	!  nref=nref_n(1)
	! ! write(0,*) "nref",maxloc(spex(:, i2, iwin, i4, i5, i3)),nref,i3, iwin, i2
	!end if
    do i3=1, nw

      ! reference window compare, by default nref=1
	 if (spex(nref, i2, iwin, i4, i5, i3) ==0.) then
		rati(:, i2, iwin, i4, i5, i3)=0.
         else
		do i1=1, n1
			if (spex(i1, i2, iwin, i4, i5, i3) ==0.) then
				rati(i1, i2, iwin, i4, i5, i3)=0.
			else		
				rati(i1, i2, iwin, i4, i5, i3) = log (spex(i1, i2, iwin, i4, i5, i3)/spex(nref, i2, iwin, i4, i5, i3))

			end if
		end do
	 end if

     end do
     end do

  end do
  end do
  end do
write(0,*) "Spectral ratio"


!!!!!!!!!!!!!!!!!! least square fitting

  d=0.; m=0.;
  slop=0.;scal=0.; ftln=0.



  do i5=1, n5
  do i4=1, n4
  do i2=1,n2

    do iwin=1, nwin
    slop(nref, i2, iwin, i4, i5)=0. 
    scal(nref, i2, iwin, i4, i5)=0.
    ftln(nref, i2, iwin, i4, i5,:)=0.
    if_peakn=maxloc(spex(nref, i2, iwin, i4, i5, 1:n3/2))
    if_peak=if_peakn(1)
    if (if_peak-nf/2 .ge. 0) then
	if_min=if_peak-nf/2
    else 
	if_min=0
    end if
     do i1=1, n1
	do iif=1,nf
	  d(iif)=rati(i1, i2, iwin, i4, i5, if_min+iif)
	end do
        !do iif=1,nf
	 ! ifmin=(fmin-ow)/dw
  	  !d(iif)=rati(i1, i2, iwin, i4, i5, ifmin+iif)
        !end do
	fmin=(if_min-1)*dw+ow
	call line_init(nf, fmin, dw)
        stat = line_lop( .true., .false., m, d)
	call solver(oper=line_lop, solv=cgstep, x=m,dat=d,niter=niter)
	slop(i1,i2,iwin,i4,i5)=m(1)
 	scal(i1,i2,iwin,i4,i5)=m(2)
	do i3=1,nw/2
		ftln(i1, i2, iwin, i4, i5, i3)=scal(i1, i2, iwin, i4,i5)+slop(i1, i2, iwin, i4,i5)*((i3-1)*dw+ow)
	end do
	
	!write(0,*) "scal, slop", scal(i3,i4,iwin),slop(i3,i4,iwin)
    end do

   end do

  end do 
  end do
  end do

write(0,*) "least square"


!  shift and smooth and eclip=0.0
	slopsft=0.
	fobj=0.
  do i5=1, n5
  do i4=1, n4
	do i2=1,n2
	do i1=ng/2,n1
	do i3=lwin/2,n3
		is1=i1-ng/2+1
		is3=(i3-lwin/2)/(lwin+dwin)+1
		do ismth=1,nsmth
			if (is3+ismth-1 .gt. nwin ) then
				exit
			else
				slopsft(i1, i2, i3, i4, i5)=slopsft(i1, i2, i3, i4, i5)+slop(is1,i2, is3+ismth-1, i4, i5)
				scalsft(i1, i2, i3, i4, i5)=scalsft(i1, i2, i3, i4, i5)+scal(is1,i2, is3+ismth-1, i4, i5)
			end if
		end do
	
		if ((slopsft(i1, i2, i3, i4, i5) .gt. 0.) .and. (slop_neg .ne. .false.)) then

			slopsft(i1, i2, i3, i4, i5) =0.
			scalsft(i1, i2, i3, i4, i5) =0.
		else
			slopsft(i1, i2, i3, i4, i5)=slopsft(i1, i2, i3, i4, i5)/nsmth
			scalsft(i1, i2, i3, i4, i5)=scalsft(i1, i2, i3, i4, i5)/nsmth

		end if

		fobj=fobj+(slopsft(i1, i2, i3, i4, i5)*slopsft(i1, i2, i3, i4, i5))/n1/n2/n3/n4/n5
	end do
	end do
	end do
  end do
  end do
write(0,*) "slope shift"





  call set_axis(axis1,n1,d1,o1+(ng)*d1/2.,"Ang")
  call set_axis(axis2,n2,d2,o2,"Athm")
  call set_axis(axis3,nwin,(lwin+dwin)*d3,o3+lwin/2.*d3,"win")
  call set_axis(axis4,n4,d4,o4,"mx")
  call set_axis(axis5,n5,d5,o5,"my")
  call set_axis(axis6,nw,dw,ow,"freq")
  call set_axis(axis7,n3,d3,o3,"z")
  call set_axis(axis8,1,1.,0.," ")
  call set_axis(axis9,n1,d1,o1,"Ang")

  spex2_raw(:, :, :, :)=spex_raw(:, :, :, mx, my, :)
  spex2(:, :, :, :)=spex(:, :, :, mx, my, :)
  rati2(:, :, :, :)=rati(:, :, :, mx, my, :)
  ftln2(:, :, :, :)=ftln(:, :, :, mx, my, :)
  write(0,*) "spex2", sum(spex2)

  call houtaxis(axis1,1,'spex_raw')
  call houtaxis(axis2,2,'spex_raw')
  call houtaxis(axis3,3,'spex_raw')
  call houtaxis(axis6,4,'spex_raw')
  call houtaxis(axis8,5,'spex_raw')

  call houtaxis(axis1,1,'spex')
  call houtaxis(axis2,2,'spex')
  call houtaxis(axis3,3,'spex')
  call houtaxis(axis6,4,'spex')
  call houtaxis(axis8,5,'spex')


  call houtaxis(axis1,1,'rati')
  call houtaxis(axis2,2,'rati')
  call houtaxis(axis3,3,'rati')
  call houtaxis(axis6,4,'rati')
  call houtaxis(axis8,5,'rati')

  call houtaxis(axis1,1,'ftln')
  call houtaxis(axis2,2,'ftln')
  call houtaxis(axis3,3,'ftln')
  call houtaxis(axis6,4,'ftln')
  call houtaxis(axis8,5,'ftln')

  call houtaxis(axis1,1,'slop')
  call houtaxis(axis2,2,'slop')
  call houtaxis(axis3,3,'slop')
  call houtaxis(axis4,4,'slop')
  call houtaxis(axis5,5,'slop')

  call houtaxis(axis9,1,'slopsft')
  call houtaxis(axis2,2,'slopsft')
  call houtaxis(axis7,3,'slopsft')
  call houtaxis(axis4,4,'slopsft')
  call houtaxis(axis5,5,'slopsft')

  call houtaxis(axis9,1,'scal')
  call houtaxis(axis2,2,'scal')
  call houtaxis(axis7,3,'scal')
  call houtaxis(axis4,4,'scal')
  call houtaxis(axis5,5,'scal')

  call houtaxis(axis5,1,'fobj')

  call sep_write(spex2_raw,'spex_raw')
  call sep_write(spex2,'spex')
  call sep_write(rati2, 'rati')
  call sep_write(ftln2, 'ftln')
  call sep_write(slop, 'slop')
  call sep_write(slopsft, 'slopsft')
  call sep_write(scal, 'scal')
  call sep_write(fobj, 'fobj')
  call sep_write(endSgn,'end')
  deallocate(ctrace1, wtrace, data, fft1)
  deallocate(spex,rati,spex_raw,spex2_raw)
  deallocate(spex2,rati2,ftln2)
  deallocate(ftln,slop,scal,m,d,slopsft, scalsft)
  deallocate(fobj)
  call sep_close()
end program

