!!! Image pertuatbation due to perturbed Q from ADCIG- Yi Shen, Jan 10, 2014
!!! input.H: input[Ang, Ath, mz, mx, my]
!!! dimg_ADCIG.x <input.H nwin=[] lwin=[] spex_raw=spex_raw.H(unstretched) spex=spex.H rati=rati.H ftln=ftln.H slop=slop.H scal=scal.H fobj=fobj.H ngroup=1 nref=1 nsmth=1 slop_neg=1 mx=mx my=my>output.H
! ! spex=spex[Ang, Ath, win, freq].H at mx and my
! ! rati=rati[Ang, Ath, win, freq].H at mx and my
! ! ftln=ftln[Ang, Ath, win, freq].H at mx and my 
! ! slop=slop[Ang, Ath, win, mx, my].H 
! ! scal=scal[Ang, Ath, win, mx, my].H 
! ! fobj=fobj[1].H
! ! ngroup=ng:sum ng points of spectra along x
! ! nref=1: compare spectra with the nref window
! ! nsmth=1: smooth slopsft along windows
! ! slop_neg=true: only consider the slope with negative value
! ! mx, my: the spex, rati and ftln at [mx, my]



program dimg_ADCIG_ref
  use sep
  use util_axisIO
  use line
  use smallsolver
  use cgstep_mod
  use wei_myfft_mod
  use wei_hamming_mod
  use smth

  implicit none

 
  integer			:: n1, n2, n3, n4, n5
  real				:: d1, d2, d3, d4, d5, o1, o2, o3, o4, o5
  integer			:: i1, i2, i3, i4, i5, iwin, ig,  is3, is4
  real				:: dw,ow
  integer			:: nsmt_slop,rectx_slop, rectz_slop
  integer			:: nw, stat
  integer			:: tbeg, tend, tend2
  logical			:: slop_neg
  integer			:: ng, nref
  integer			:: dwin, nwin, nwin2, lwin, niter
  integer			:: if_peakn(1), if_peak
  real				:: f_rang,fmin
  integer			:: nf, iif, ifmin
  type(myaxis)  		:: axis1,axis2,axis3,axis4,axis5,axis6,axis7,axis8,axis9
  complex, allocatable 		:: ctrace1(:),wtrace(:),ctrace2(:)
  complex, allocatable		:: fft1(:,:,:,:,:,:),fft2(:,:,:,:,:,:)
  real, allocatable		:: spex(:,:,:,:,:,:), spex_raw(:,:,:,:,:,:),spex2(:,:,:,:,:,:), spex2_raw(:,:,:,:,:,:)
  real, allocatable		:: spexf(:,:,:,:),spexf_raw(:,:,:,:)
  real, allocatable		:: rati(:,:,:,:,:,:), ratif(:,:,:,:)
  real, allocatable		:: ftln(:,:,:,:,:,:), ftlnf(:,:,:,:)
  real, allocatable		:: slop(:,:,:,:,:),slopsft(:,:,:,:,:), scalsft(:,:,:,:,:)
  real, allocatable		:: scal(:,:,:,:,:)
  real, allocatable		:: d(:), m(:)
  real, allocatable 		:: data(:,:,:,:,:)
  real, allocatable		:: fobj(:)
  real, dimension (1) 		:: endSgn
  integer			:: mx, my
  real				:: angle, corr
  real				:: loc
  real    			:: ll, wt
  integer 			:: ill,il
  real, allocatable		:: maxspex2(:,:,:,:,:)
  real, allocatable 		:: img(:,:,:,:,:)
  real				:: eps
  integer			:: nodes
  integer,external		:: omp_get_num_threads,  omp_get_num_procs,OMP_SET_NUM_THREADS, omp_get_thread_num

  call sep_init()


	
  call from_history ('n1',n1)
  call from_history ("d1",d1)
  call from_history ("o1",o1)

  call from_history ('n2', n2)
  call from_history ("d2", d2)
  call from_history ("o2", o2) 

  call from_history ('n3',n3)
  call from_history ("d3",d3)
  call from_history ("o3",o3)

  call from_history ('n4',n4)
  call from_history ("d4",d4)
  call from_history ("o4",o4)

  call from_history ('n5', n5)
  call from_history ("d5", d5)
  call from_history ("o5", o5) 

  ow=0.
  nw=n3;
  dw = 1./(n3*d3)
  call from_param("nwin",nwin,10)
  call from_param("lwin",lwin,n5/5)
  call from_param("f_rang",f_rang, ((nw-1)*dw)/2.)
  call from_param("niter", niter,50)
  call from_param("ngroup", ng,1)
  call from_param("nref", nref,1)
  call from_param("slop_neg", slop_neg,.true.)
  call from_param("mx", mx,1)
  call from_param("my", my,1)
  call from_param("nsmt_slop", nsmt_slop,1)
  call from_param("rectx_slop", rectx_slop,1)
  call from_param("rectz_slop", rectz_slop, 1)

  if(nwin==1) then
	dwin=0
  else
	  dwin=(n3-lwin*nwin)/(nwin-1)
  end if
  nwin2=n3/(lwin+dwin)
  nf=f_rang/dw+1
  write(0,*)'dwin,nf',dwin+lwin, nf
  allocate(ctrace1(n3),ctrace2(n3),wtrace(nw),data(n1, n2, n3, n4, n5), img(n1, n2, n3, n4, n5), fft1(n1, n2, nwin, n4, n5, nw),fft2(n1, n2, nwin2, n4, n5, nw))
  allocate(spex(n1 ,n2, nwin, n4, n5, nw),spex2(n1 ,n2, nwin2, n4, n5, nw),rati(n1 ,n2, nwin, n4, n5, nw),ftln(n1 ,n2, nwin, n4, n5, nw), spex_raw(n1 ,n2, nwin, n4, n5, nw),spex2_raw(n1 ,n2, nwin2, n4, n5, nw),maxspex2(n1,n2,nwin2,n4,n5))
  allocate(spexf(n1 ,n2, nwin, nw),ratif(n1 ,n2, nwin, nw), ftlnf(n1 ,n2, nwin, nw),spexf_raw(n1 ,n2, nwin, nw))
  allocate(slop(n1 ,n2, nwin, n4, n5),scal(n1 ,n2, nwin, n4, n5))
  allocate(scalsft(n1 ,n2 , n3, n4, n5), slopsft(n1 ,n2 , n3, n4, n5))
  allocate(m(2),d(nf))
  allocate(fobj(1))
  call sep_read(data)

fft1=0.; fft2=0;  spex=0.0;  spex_raw=0.0; spex2=0.0; spex2_raw=0.0;
rati=0.; slop=0.;scal=0.; ftln=0.; d=0.; m=0.;  slopsft=0.;fobj=0.
wtrace=0.;  img=0.
  !setup OpenMP stuff
  stat= OMP_SET_NUM_THREADS(6)
  !$OMP PARALLEL
  nodes = omp_get_num_threads()
  !$OMP END PARALLEL
  write(0,*)"nthread =", nodes, omp_get_num_procs()

do i2=1,n2
!!$OMP parallel do default(shared) private(i1,angle,corr,i5, i4,iwin, tbeg, tend,tend2,ig,i3,loc, ll, ill, il, wt,if_peakn,if_peak, ifmin,iif,d,fmin,m,is4,is3,eps,maxspex2,wtrace)

do i1=1,n1
write(0,*) "Angel(i1)", i1
write(0,*) "data", sum(data(i1, i2 ,:,:,:))
!=======================================================================
!1. Compute FFT
 write(0,*) "Computing FFT"
!=======================================================================
  do i5=1, n5
    do i4=1, n4
      do iwin=1,nwin
      	tbeg=(iwin-1)*(lwin+dwin)+1
	tend=tbeg+lwin-1    
	if(tend .gt. n3 ) then
	  tend=n3
        end if
        ctrace1=0.
        ctrace1(tbeg:tend)=data(i1, i2 ,tbeg:tend , i4, i5)
	call FFT1DX(ctrace1, 1)
        fft1(i1, i2, iwin, i4, i5, :) =ctrace1	
      end do
      do iwin=1,nwin2
      	tbeg=(iwin-1)*(lwin+dwin)+1
	tend2=tbeg+lwin+dwin-1 
	if(tend2 .gt. n3 ) then
	  tend2=n3
        end if
	ctrace2=0.
        ctrace2(tbeg:tend2)=data(i1, i2 ,tbeg:tend2 , i4, i5)
	call FFT1DX(ctrace2, 1)
        fft2(i1, i2, iwin, i4, i5, :) =ctrace2	
      end do
    end do
  end do
  write(0,*) "fft1, fft2",sum(real(fft1)), sum(real(fft2))

!=======================================================================
!2. Compute spectra: smooth, correction
 write(0,*) "Computing spectra"
!=======================================================================

  ! 2.1 Smooth 
 do i5=1,n5
  do i4=1,n4
     do ig=1,ng
	if (i4+ig-1 .gt. n4) then
	  exit
	else
          do iwin=1, nwin
    	    spex_raw(i1, i2, iwin, i4, i5, :)=spex_raw(i1, i2, iwin, i4, i5, :)+abs(fft1(i1, i2, iwin, i4+ig-1, i5, :))
            stat= base_tris1d_oper(spex_raw(i1, i2, iwin, i4,i5,:),1,1) 
	   end do
	  do iwin=1, nwin2 
    	    spex2_raw(i1, i2, iwin, i4, i5, :)=spex2_raw(i1, i2, iwin, i4, i5, :)+abs(fft2(i1, i2, iwin, i4+ig-1, i5, :))
	    stat= base_tris1d_oper(spex2_raw(i1, i2, iwin, i4,i5,:),1,1)  !rect_spex,nsmt_spex, 2, 3
	  end do
	end if
     end do

  end do
 end do 
  ! 2.2 correction

  angle=(d1*(i1-1)+o1)*3.14159265/180.
  corr=cos(angle)
  do i3=1, n3-1
    loc=(ow+(i3-1)*dw)*corr
    ll = (loc-ow)/dw
    ill=ll
    il=1+ill  
    wt = ll-ill
    spex(i1, i2, :, :, :, i3)=spex_raw(i1, i2, :, :, :, il)*(1.-wt)+spex_raw(i1, i2, :, :, :, il+1)*wt
    spex2(i1, i2, :, :, :, i3)=spex2_raw(i1, i2, :, :, :, il)*(1.-wt)+spex2_raw(i1, i2, :, :, :, il+1)*wt
  end do
 ! spex(i1, i2, :, :, :, :)=spex_raw(i1, i2, :, :, :, :)
 ! spex2(i1, i2, :, :, :, :)=spex_raw(i1, i2, :, :, :, :)
  write(0,*) "spex, spex2",sum(spex(i1, i2, :, :, :, :)), sum(spex2(i1, i2, :, :, :, :))
!=======================================================================
!3. Compute spectral ratio by least squre
 write(0,*) "Compute spectra ratio by least square"
!=======================================================================

  do i5=1, n5
    do i4=1, n4
      do iwin=1, nwin
        do i3=1, nw
	  if (spex(i1, i2, iwin, nref, i5, i3) ==0.) then
            rati(i1, i2, iwin, :, i5, i3)=0.
          else if (spex(i1, i2, iwin, i4, i5, i3) ==0.) then
	    rati(i1, i2, iwin, i4, i5, i3)=0.
	  else	
	    rati(i1, i2, iwin, i4, i5, i3) = log(spex(i1, i2, iwin, i4, i5, i3)/spex(i1, i2, iwin, nref, i5, i3))
	  end if
        end do
	if_peakn=maxloc(spex(i1, i2, iwin, nref,i5,1:nw/2))
	if_peak=if_peakn(1)
	ifmin=max(if_peak-nf/2,0)
  	!write(0,*) "stop1, ifmin", ifmin
        do iif=1,nf
  	  d(iif)=rati(i1, i2, iwin, i4, i5, ifmin+iif)
        end do
 	fmin=(ifmin-1)*dw+ow
        call line_init(nf, fmin, dw)
 	stat = line_lop( .true., .false., m, d)
	call solver(oper=line_lop, solv=cgstep, x=m,dat=d,niter=niter)
	slop(i1,i2,iwin,i4,i5)=m(1)
 	scal(i1,i2,iwin,i4,i5)=m(2)
	do i3=1,nw/2
	  ftln(i1,i2,iwin,i4,i5,i3)=scal(i1,i2,iwin,i4,i5)+slop(i1,i2,iwin,i4,i5)*((i3-1)*dw+ow)
	end do
      end do
   end do
  end do
  write(0,*) "slop",sum(slop(i1, i2, :, :, :))

!=======================================================================
!4. Shift the slope
 write(0,*) "shift the slope"
!=======================================================================

  do i4=ng/2,n4
    do i5=1,n5
      do i3=lwin/2,n3
	is4=i4-ng/2+1
	is3=(i3-lwin/2)/(lwin+dwin)+1
	if (is3 .gt. nwin) then
	  exit
	else
	  slopsft(i1, i2, i3, i4, i5)=slop(i1, i2, is3,is4,i5)
	  scalsft(i1, i2, i3, i4, i5)=scal(i1, i2, is3,is4,i5)
	end if
	if ((slopsft(i1, i2, i3, i4, i5) .gt. 0.) .and. (slop_neg .ne. .false.)) then
	  slopsft(i1, i2, i3, i4, i5) =0.
	  scalsft(i1, i2, i3, i4, i5) =0.
	else
	  slopsft(i1, i2, i3, i4, i5)=slopsft(i1, i2, i3, i4, i5)
	  scalsft(i1, i2, i3, i4, i5)=scalsft(i1, i2, i3, i4, i5)
	end if
	fobj=fobj+(slopsft(i1, i2, i3, i4, i5)*slopsft(i1, i2, i3, i4, i5))/n1/n2/n3/n4/n5
      end do
    end do
  end do
  do i5=1, n5
      stat=base_tris2d_oper(slopsft(i1, i2,:, :, i5),rectz_slop,rectx_slop,nsmt_slop) 
      stat=base_tris2d_oper(scalsft(i1, i2,:, :, i5),rectz_slop,rectx_slop,nsmt_slop) 
  end do
  write(0,*) "slopsft", sum(slopsft(i1, i2, :, :, :))

!=======================================================================
!5. Computing dimg
 write(0,*) "Computing dimg"
!=======================================================================

  eps=sum(spex2(:,:,:,:,:,:))/nw/n5/n4/nwin2/100/n2/n1
  do i5=1, n5
    do i4=1, n4
      do iwin=1, nwin2
	is3=(iwin-1)*(lwin+dwin)+1
	maxspex2(i1, i2, iwin, i4, i5)=sum(spex2(i1, i2, iwin, i4, i5,:))/nw
 	wtrace(1)=fft2(i1, i2, iwin, i4, i5, 1)/(maxspex2(i1, i2, iwin, i4, i5)+eps)*(slopsft(i1, i2, is3,i4, i5)*(ow))!/exp(scalsft(i3, i4, is5))
	do i3=2,(nw/2)+1
    	    wtrace(i3) = (fft2(i1, i2, iwin, i4, i5, i3))/(maxspex2(i1, i2, iwin, i4, i5)+eps)  *(slopsft(i1, i2, is3,i4, i5)*(ow+dw*(i3-1)))
    	    wtrace(nw-i3+2) = (fft2(i1, i2, iwin, i4, i5, nw-i3+2))/(maxspex2(i1, i2, iwin, i4, i5)+eps)* (slopsft(i1, i2, is3,i4, i5)*(ow+dw*(i3-1)))
        end do
        call FFT1DX(wtrace, -1)
        img(i1, i2, :, i4, i5) = img(i1, i2, :, i4, i5)+ real(wtrace(:))
        wtrace = 0.
      end do
    end do
  end do


end do ! n1=ang
!!$OMP END PARALLEL DO
end do ! n2=ath

write(0,*) "dimg", sum(img(:,:,:,:,:))
  write(0,*) "fobj", fobj

  call set_axis(axis1,n1,d1,o1,"Ang")
  call set_axis(axis2,n2,d2,o2,"Athm")
  call set_axis(axis3,nwin,(lwin+dwin)*d3,o3+lwin/2.*d3,"win")
  call set_axis(axis4,n4,d4,o4,"mx")
  call set_axis(axis5,n5,d5,o5,"my")
  call set_axis(axis6,nw,dw,ow,"freq")
  call set_axis(axis7,n3,d3,o3,"z")
  call set_axis(axis8,1,1.,0.," ")
  call set_axis(axis9,n4,d4,o4+(ng)*d3/2,"mx")

  spexf_raw(:, :, :, :)=spex_raw(:, :, :, mx, my, :)
  spexf(:, :, :, :)=spex(:, :, :, mx, my, :)
  ratif(:, :, :, :)=rati(:, :, :, mx, my, :)
  ftlnf(:, :, :, :)=ftln(:, :, :, mx, my, :)
  !write(0,*) "ftlnf",ftlnf(1,:,:,:)
  call houtaxis(axis1,1,'spex_raw')
  call houtaxis(axis2,2,'spex_raw')
  call houtaxis(axis3,3,'spex_raw')
  call houtaxis(axis6,4,'spex_raw')
  call houtaxis(axis8,5,'spex_raw')

  call houtaxis(axis1,1,'spex')
  call houtaxis(axis2,2,'spex')
  call houtaxis(axis3,3,'spex')
  call houtaxis(axis6,4,'spex')
  call houtaxis(axis8,5,'spex')


  call houtaxis(axis1,1,'rati')
  call houtaxis(axis2,2,'rati')
  call houtaxis(axis3,3,'rati')
  call houtaxis(axis6,4,'rati')
  call houtaxis(axis8,5,'rati')

  call houtaxis(axis1,1,'ftln')
  call houtaxis(axis2,2,'ftln')
  call houtaxis(axis3,3,'ftln')
  call houtaxis(axis6,4,'ftln')
  call houtaxis(axis8,5,'ftln')

  call houtaxis(axis1,1,'slop')
  call houtaxis(axis2,2,'slop')
  call houtaxis(axis3,3,'slop')
  call houtaxis(axis4,4,'slop')
  call houtaxis(axis5,5,'slop')

  call houtaxis(axis1,1,'slopsft')
  call houtaxis(axis2,2,'slopsft')
  call houtaxis(axis7,3,'slopsft')
  call houtaxis(axis9,4,'slopsft')
  call houtaxis(axis5,5,'slopsft')

  call houtaxis(axis1,1,'scal')
  call houtaxis(axis2,2,'scal')
  call houtaxis(axis7,3,'scal')
  call houtaxis(axis9,4,'scal')
  call houtaxis(axis5,5,'scal')

  call houtaxis(axis5,1,'fobj')

  call sep_write(spexf_raw,'spex_raw')
  call sep_write(spexf,'spex')
  call sep_write(ratif, 'rati')
  call sep_write(ftlnf, 'ftln')
  call sep_write(slop, 'slop')
  call sep_write(slopsft, 'slopsft')
  call sep_write(scal, 'scal')
  call sep_write(fobj, 'fobj')
  call sep_write(img)
  call sep_write(endSgn,'end')
  deallocate(ctrace1,ctrace2, wtrace, data, fft1, fft2, img)
  deallocate(spex,spex2,rati,spex_raw,spex2_raw,maxspex2)
  deallocate(spexf_raw, spexf,ratif,ftlnf)
  deallocate(ftln,slop,scal,m,d,slopsft, scalsft)
  deallocate(fobj)
  call sep_close()
end program

