!!! Image pertuatbation due to perturbed Q from post stack image - Yi Shen, Feb 26, 2013
!!! input.H: input[hx, hy, mx, my, mz]
!!! dimg_range.x <input.H nwin=[] lwin=[] f_rang=[] vel=[] spex=spex.H rati=rati.H ftln=ftln.H slop=slop.H scal=scal.H slopsft=slopsft.H fobj=fobj.H neigh=n ver=y  nref=1 nsmt_mx=1 nsmt_spex=1 rect_spex=1 nsmt_slop=1 rectx_slop=1 rectz_slop=1 slop_neg=1>output.H
! ! spex=spex[mx, my, win, freq].H 
! ! rati=rati[mx, my, win, freq].H 
! ! ftln=ftln[mx, my, win, freq].H 
! ! slop=slop[mx, my, win, freq].H 
! ! scal=scal[mx, my, win, freq].H 
! ! fobj=fobj[1].H
! ! neigh=n:compare spectra with the reference window; y: compare spectral with the previous window
! ! ver=y:compare spectral along z; n: compare spectral along x
! ! nsmt=ng:sum ng points of spectra along x
! ! nref=1: compare spectra with the nref window
! ! nsmth_slop/rect_slop=1: smooth slopsft along x and z
! ! nsmth_spex/rect_spex=1: smooth spex along f
! ! slop_neg=true: only consider the slope with negative value
! ! f_rang=the range of interested frequency range whose center is the peak frequency
! ! vel=vel[mx, my, mz]: input for spectral stretch correction


!!! July 10, BP
!!! 1. Add opt=7 for image pertuabation: small window normalized by avg(spex2)
!!! 2. if (neigh): slop is the cumulative summation from nref; for horizontal comparison only

program dimg_range
  use sep
  use util_axisIO
  use line
  use smallsolver
  use cgstep_mod
  use wei_myfft_mod
  use wei_hamming_mod
  use smth

  implicit none

 
  integer			:: n1, n2, n3, n4, n5
  real				:: d1, d2, d3, d4, d5, o1, o2, o3, o4, o5
  integer			:: i1, i2, i3, i4, i5, iwin, ig, is3, is5
  real				:: dw,ow
  integer			:: nsmt_mx, nsmt_spex, nsmt_slop, rect_spex, rectx_slop, rectz_slop
  integer			:: nw, stat
  integer			:: tbeg, tend,tend2
  logical			:: slop_neg
  integer			:: nref
  integer			:: dwin, nwin, lwin, niter, nwin2
  real				:: eps
  type(myaxis)  		:: axis1,axis2,axis3,axis4,axis5,axis6,axis7,axis8
  complex, allocatable 		:: ctrace1(:),ctrace2(:),wtrace(:)
  complex, allocatable		:: fft1(:,:,:,:),fft2(:,:,:,:)
  real, allocatable		:: spex(:,:,:,:), spex2(:,:,:,:), spexr(:,:,:,:)
  real, allocatable		:: rati(:,:,:,:)
  real, allocatable		:: ftln(:,:,:,:)
  real, allocatable		:: slop(:,:,:),slopsft(:,:,:), scalsft(:,:,:), slop_tmp(:,:,:), scal_tmp(:,:,:)
  real, allocatable		:: scal(:,:,:)
  real, allocatable		:: d(:), m(:)
  real, allocatable 		:: data(:,:,:,:,:),img(:,:,:,:,:),vel(:,:,:)
  real, allocatable		:: maxspex2(:,:,:)
  real, allocatable		:: fobj(:)
  real, dimension (1) 		:: endSgn
  real			        :: start, finish
  integer			:: i34,nodes
  integer			:: if_peakn(1), if_peak
  real				:: fmin, f_rang
  integer			:: nf, iif, ifmin
  real				:: vref, corr, vint
  real				:: loc
  real    			:: ll, wt
  integer 			:: ill,il
  
 
  call cpu_time(start)

  call sep_init()


	
  call from_history ('n1',n1)
  call from_history ("d1",d1)
  call from_history ("o1",o1)

  call from_history ('n2', n2)
  call from_history ("d2", d2)
  call from_history ("o2", o2) 

  call from_history ('n3',n3)
  call from_history ("d3",d3)
  call from_history ("o3",o3)

  call from_history ('n4',n4)
  call from_history ("d4",d4)
  call from_history ("o4",o4)

  call from_history ('n5', n5)
  call from_history ("d5", d5)
  call from_history ("o5", o5) 

  ow=0.
  nw=n5;
  dw = 1./(n5*d5)
  call from_param("nwin",nwin,10)
  call from_param("lwin",lwin,n5/5)
  call from_param("f_rang",f_rang, ((nw-1)*dw)/2.)
  call from_param("niter", niter,50)
  call from_param("nref", nref,1)
  call from_param("nsmt_mx", nsmt_mx,1)
  call from_param("nsmt_spex", nsmt_spex,1)
  call from_param("nsmt_slop", nsmt_slop,1)
  call from_param("rect_spex", rect_spex, 1)
  call from_param("rectx_slop", rectx_slop,1)
  call from_param("rectz_slop", rectz_slop, 1)
  call from_param("slop_neg", slop_neg,.true.)
  if(nwin==1) then
	dwin=0
  else
	  dwin=(n5-lwin*nwin)/(nwin-1)
  end if
  write(0,*)'dwin',dwin+lwin
  nwin2=n5/(lwin+dwin)
  nf=f_rang/dw+1
  i1=1; i2=1
  allocate(ctrace1(n5),ctrace2(n5), wtrace(nw),data(n1, n2, n3, n4, n5), img(n1, n2, n3, n4, n5),fft1(n3, n4, nwin, nw),fft2(n3, n4, nwin2, nw),vel(n3,n4,n5))
  allocate(spex(n3, n4, nwin, nw),spexr(n3, n4, nwin, nw),spex2(n3,n4,nwin2,nw),rati(n3, n4, nwin, nw), ftln(n3, n4, nwin, nw))
  allocate(slop(n3, n4, nwin),scal(n3, n4, nwin),slopsft(n3,n4,n5),scalsft(n3,n4,n5),  slop_tmp(n3 ,n4, n5), scal_tmp(n3, n4, n5))
  allocate(m(2),d(nf))
  allocate(maxspex2(n3, n4, nwin2))
  allocate(fobj(1))
  call sep_read(data)
  call sep_read(vel,'vel')





!=======================================================================
!1. Compute FFT
 write(0,*) "Computing FFT"
!=======================================================================
  fft1=0.; fft2=0.;  spex=0.0; spex2=0.0; spexr=0.0


  do i34=1, n3*n4
     i4=(i34-1)/n3+1; i3=i34-(i34-1)/n3*n3
    ! write(0,*) "n4, n3, i4, i3", n4, n3, i4, i3 
!  do i4=1,n4
 !   do i3=1,n3
      !=========== FFT1 ============================================
      !==large windowed FFT for spex:no hamming window, nz=nw
      do iwin=1,nwin    
	tbeg=(iwin-1)*(lwin+dwin)+1
	tend=tbeg+lwin-1    
	if(tend .gt. n5 ) then
	  tend=n5
        end if
        ctrace1=0.;
        ctrace1(tbeg:tend)=data(i1, i2 ,i3 , i4, tbeg:tend)
	call FFT1DX(ctrace1, 1)
        fft1(i3, i4, iwin, :) =ctrace1	
      end do
      !=========== FFT2 ============================================
      !==small windowed FFT for dimg
      do iwin=1,nwin2
      	tbeg=(iwin-1)*(lwin+dwin)+1
	tend2=tbeg+lwin+dwin-1 
	if(tend2 .gt. n5 ) then
	  tend2=n5
        end if
	ctrace2=0.
        ctrace2(tbeg:tend2)=data(i1, i2 ,i3 , i4, tbeg:tend2)
	call FFT1DX(ctrace2, 1)
        fft2(i3, i4, iwin, :) =ctrace2	
      end do
    !end do
  end do

write(0,*) "fft1, fft2", sum(fft1), sum(fft2)

!=======================================================================
!2. Compute spectra
 write(0,*) "Computing spectra"
!=======================================================================

  do i34=1, n3*n4
     i4=(i34-1)/n3+1; i3=i34-(i34-1)/n3*n3
  !do i4=1,n4
  !  do i3=1,n3
      !=========== SPEX1 ============================================
      !==smooth along freq and mx
      do ig=1,nsmt_mx
	if (i3+ig-1 .gt. n3) then
	  exit
	else
    	  spexr(i3, i4, :, :)=spexr(i3,i4,:,:)+abs(fft1(i3+ig-1, i4, :, :))
    	  spex2(i3, i4, :, :)=spex2(i3,i4,:,:)+abs(fft2(i3+ig-1, i4, :, :))
	end if
      end do
      do iwin=1, nwin
	stat= base_tris1d_oper(spexr(i3, i4, iwin, :),rect_spex,nsmt_spex)  
      end do 
      do iwin=1, nwin2
	stat= base_tris1d_oper(spex2(i3, i4, iwin, :),rect_spex,nsmt_spex)  
      end do 
    !end do
  end do
  vref=vel(1,1,1);
  do i34=1, n3*n4
    i4=(i34-1)/n3+1; i3=i34-(i34-1)/n3*n3
    do iwin=1,nwin
     tbeg=(iwin-1)*(lwin+dwin)+1; tend=tbeg+lwin-1
     vint=sum(vel(i3, i4, tbeg:tend))/(tend-tbeg+1)
     corr=vref/vint
     
      do i5=1,n5-1
	loc=(ow+(i5-1)*dw)*corr
	ll = (loc-ow)/dw
        ill=ll
       	il=1+ill  
       	wt = ll-ill
	!write(0,*) "il,i5",corr, loc, il,i5
        spex(i3, i4, iwin, i5)=spexr(i3, i4, iwin, il)*(1.-wt)+spexr(i3, i4, iwin, il+1)*wt
	
      end do
    end do
  end do
  spex=spexr    

write(0,*) "spex1, spex2", sum(spex), sum(spex2)

!=======================================================================
!3. Compute spectral ratio by least squre
 write(0,*) "Compute spectra ratio by least square"
!=======================================================================
  rati=0.; slop=0.;scal=0.; ftln=0.; d=0.; m=0.;

  do i34=1, n3*n4
     i4=(i34-1)/n3+1; i3=i34-(i34-1)/n3*n3
  !do i4=1, n4
    !do i3=1,n3
      do iwin=1,nwin
        !=========== Compute spectra ratio ============================================
        do i5=1, nw
	  if (spex(nref, i4, iwin, i5) ==0.) then
            rati(i3, i4, iwin, i5)=0.
          else if (spex(i3, i4, iwin, i5) ==0.) then
	    rati(i3, i4, iwin, i5)=0.
	  else	
	    rati(i3, i4, iwin, i5) = log(spex(i3, i4, iwin, i5)/spex(nref, i4, iwin, i5))
	  end if
        end do
    !  write(0,*) "rati, i3, i4",sum(rati),i3,i4
        !=========== Compute slop using least square  ================================
	if_peakn=maxloc(spex(nref,i4,iwin,1:nw))
	if_peak=if_peakn(1)
	ifmin=max(if_peak-nf/2,0)
        do iif=1,nf
  	  d(iif)=rati(i3, i4, iwin, ifmin+iif)
        end do
 	fmin=(ifmin-1)*dw+ow
        call line_init(nf, fmin, dw)
 	stat = line_lop( .true., .false., m, d)
	call solver(oper=line_lop, solv=cgstep, x=m,dat=d,niter=niter)
	slop(i3,i4,iwin)=m(1)
 	scal(i3,i4,iwin)=m(2)
	do i5=1,nw/2
	  ftln(i3,i4,iwin,i5)=scal(i3,i4,iwin)+slop(i3,i4,iwin)*((i5-1)*dw+ow)
	end do
      end do
    !end do
  end do

        slop(nref,:,:)=0. !???
        scal(nref,:,:)=0. !???
        ftln(nref,:,:,:)=0. !???
write(0,*) "rati, slop, scal",sum(rati), sum(slop), sum(scal)
!=======================================================================
!4. Shift the slope
 write(0,*) "shift the slope"
!=======================================================================
  slopsft=0.;fobj=0.
  do i3=nsmt_mx/2,n3
    do i4=1,n4
      do i5=lwin/2,n5
	is3=i3-nsmt_mx/2+1
	is5=(i5-lwin/2)/(lwin+dwin)+1
	if (is5 .gt. nwin) then
	  exit
	else
	  slopsft(i3,i4,i5)=slop(is3,i4,is5)
	  scalsft(i3,i4,i5)=scal(is3,i4,is5)
	end if
	if ((slopsft(i3, i4, i5) .gt. 0.) .and. (slop_neg .ne. .false.)) then
	  slopsft(i3, i4, i5) =0.
	  scalsft(i3, i4, i5) =0.
	else
	  slopsft(i3,i4,i5)=slopsft(i3,i4,i5)
	  scalsft(i3,i4,i5)=scalsft(i3,i4,i5)
	end if
	fobj=fobj+(slopsft(i3, i4, i5)*slopsft(i3, i4, i5))/n3/n4/n5
      end do
    end do
  end do
  do i4=1, n4
      stat=base_tris2d_oper(slopsft(:, i4, :),rectx_slop,rectz_slop,nsmt_slop) 
      stat=base_tris2d_oper(scalsft(:, i4, :),rectx_slop,rectz_slop,nsmt_slop) 
  end do
  write(0,*) "fobj", sum(slopsft(:,:,:))
!=======================================================================
!5. Computing dimg
 write(0,*) "Computing dimg"
!=======================================================================
  wtrace=0.
  img=0.
  eps=sum(spex2(:,:,:,:))/nw/n3/n4/nwin2/100

  do i34=1, n3*n4
     i4=(i34-1)/n3+1; i3=i34-(i34-1)/n3*n3
  !do i4=1, n4
   ! do i3=1,n3
    !!! dimg: small windowed local FFT * correction; normalized by avg(spex)
      do iwin=1, nwin2
	is5=(iwin-1)*(lwin+dwin)+1
	maxspex2(i3 ,i4, iwin)=sum(spex2(i3, i4,iwin, :))/nw

 	wtrace(1)=fft2(i3,i4,iwin,1)/(maxspex2(i3, i4, iwin)+eps)*(slopsft(i3, i4, is5)*(ow))!/exp(scalsft(i3, i4, is5))
	
        do i5=2,(nw/2)+1
    	    wtrace(i5) = (fft2(i3, i4, iwin, i5))/(maxspex2(i3, i4, iwin)+eps)  *(slopsft(i3, i4, is5)*(ow+dw*(i5-1)))
    	    wtrace(nw-i5+2) = (fft2(i3, i4, iwin, nw-i5+2))/(maxspex2(i3, i4, iwin)+eps)* (slopsft(i3, i4, is5)*(ow+dw*(i5-1)))
        end do
        call FFT1DX(wtrace, -1)
        img(i1, i2, i3, i4, :) = img(i1, i2, i3, i4, :)+ real(wtrace(:))
        wtrace = 0.
      end do
    !end do
  end do

  write(0,*) "dimg", sum(img(:,:,:,:,:))

  call to_history ('n1',n1)
  call to_history ("d1",d1)
  call to_history ("o1",o1)

  call to_history ('n2', n2)
  call to_history ("d2", d2)
  call to_history ("o2", o2) 

  call to_history ('n3',n3)
  call to_history ("d3",d3)
  call to_history ("o3",o3)

  call to_history ('n4', n4)
  call to_history ("d4", d4)
  call to_history ("o4", o4) 

  call to_history ('n5', n5)
  call to_history ("d5", d5)
  call to_history ("o5", o5) 



  call set_axis(axis1,n3,d3,o3+(nsmt_mx)*d3/2.,"mx")
  call set_axis(axis2,n4,d4,o4,"my")
  call set_axis(axis3,nwin,(lwin+dwin)*d5,o5+lwin/2.*d5,"win")
  call set_axis(axis4,nw,dw,ow,"freq")
  call set_axis(axis5,1,1.,0.," ")
  call set_axis(axis6,n3,d3,o3,"mx")
  call set_axis(axis7,n4,d4,o4,"my")
  call set_axis(axis8,n5,d5,o5,"z")


  call houtaxis(axis1,1,'spex')
  call houtaxis(axis2,2,'spex')
  call houtaxis(axis3,3,'spex')
  call houtaxis(axis4,4,'spex')
  call houtaxis(axis5,5,'spex')

  call houtaxis(axis1,1,'rati')
  call houtaxis(axis2,2,'rati')
  call houtaxis(axis3,3,'rati')
  call houtaxis(axis4,4,'rati')
  call houtaxis(axis5,5,'rati')

  call houtaxis(axis1,1,'ftln')
  call houtaxis(axis2,2,'ftln')
  call houtaxis(axis3,3,'ftln')
  call houtaxis(axis4,4,'ftln')
  call houtaxis(axis5,5,'ftln')

  call houtaxis(axis1,1,'slop')
  call houtaxis(axis2,2,'slop')
  call houtaxis(axis3,3,'slop')
  call houtaxis(axis5,4,'slop')
  call houtaxis(axis5,5,'slop')

  call houtaxis(axis6,1,'slopsft')
  call houtaxis(axis7,2,'slopsft')
  call houtaxis(axis8,3,'slopsft')
  call houtaxis(axis5,4,'slopsft')
  call houtaxis(axis5,5,'slopsft')

  call houtaxis(axis1,1,'scal')
  call houtaxis(axis2,2,'scal')
  call houtaxis(axis3,3,'scal')
  call houtaxis(axis4,4,'scal')
  call houtaxis(axis5,5,'scal')

  call houtaxis(axis5,1,'fobj')

  call sep_write(spex,'spex')
  call sep_write(rati, 'rati')
  call sep_write(ftln, 'ftln')
  call sep_write(slop, 'slop')
  call sep_write(slopsft, 'slopsft')
  call sep_write(scal, 'scal')
  call sep_write(fobj, 'fobj')
  call sep_write(img)
  call sep_write(endSgn,'end')
  deallocate(ctrace1,ctrace2, wtrace, data, fft1,fft2,img,vel)
  deallocate(spex,spex2,spexr,rati)
  deallocate(ftln,slop,scal,m,d,slopsft, scalsft, slop_tmp, scal_tmp)
  deallocate(maxspex2)
  deallocate(fobj)
  call cpu_time(finish)

  write(0,*)"***********************"
  write(0,*)"      Finished!!!      "
  write(0,*)"Time(sec) =" , (finish-start)
  write(0,*)"***********************"
  call sep_close()


end program

