!!! Yi's change:
!!! 1. define private input
!!! 2. subroutine fbi_init4(w0, pw1, pw2, pw3, pw4): cp param
!!! 3. subroutine fbi_alloc(wavelet_in): allocate ; call prop init
!!! 4. subroutine model_update2(vel) : cp bq; calcaulte vel2dt, gama, eta, tau, gama_mean
!!! 5. call model_update2 in subroutine M_lop2
!!! 6. Add qcomp in prop_op and prop_op2
!!!	1. only change qcomp into false and true in L_lop
!!! 7. Add qpertub in W_lop
!!! 8. Add qpertub_init in subroutine fbi_alloc
!!! 9. Add call qpertub_op2 in W_lop2

module fbi_mod

  use sep
  use mem_mod
  use tomo_mod
  use sscale_mod
  use prop_mod
  use scat_mod
  use escats_mod
  use escatr_mod
  use escat_refl_mod
  use secder_mod
  use qpertub_mod

  implicit none
  integer, private                                     :: nt, n1, n2, nt2, wfld_j
  integer, private                                     :: sou_nx, sou_ox, sou_dx, sou_z, isou, sou_x, off_x
  integer, private                                     :: rec_nx, rec_ox, rec_dx, rec_z, irec, rec_x
  integer, private                                     :: nlag, olag, lag_type, geom_type, it
  integer, private                                     :: bc1, bc2, bc3, bc4
  real, private                                        :: dt, d1, o1, d2, o2, dtw
  logical, private                                     :: sou_ghost, rec_ghost
  real, dimension(:), allocatable, private             :: wavelet
  real, dimension(:,:), allocatable, private           :: vel, vel_mult, veldt2, vwt, wt
  real, dimension(:,:,:), allocatable, private         :: wfld1, wfld2
  real, dimension(:,:,:), allocatable, private         :: temp1, temp2
  real, private  			        	:: w0, pw1, pw2, pw3, pw4  !!! Yi's change
  real, dimension(:), allocatable,private		:: gama_mean !!! Yi's change
  real, dimension(:,:), allocatable, private		:: bq, gama, tau, eta, vel2dt !!! Yi's change
  contains

  subroutine fbi_init1(n1_in, o1_in, d1_in, n2_in, o2_in, d2_in, bc1_in, bc2_in, bc3_in, bc4_in) ! Copying variables 1
    integer                             :: n1_in, n2_in, bc1_in, bc2_in, bc3_in, bc4_in
    real                                :: d1_in, o1_in, d2_in, o2_in
    n1 = n1_in
    n2 = n2_in
    d1 = d1_in
    o1 = o1_in
    d2 = d2_in
    o2 = o2_in
    bc1 = bc1_in
    bc2 = bc2_in
    bc3 = bc3_in
    bc4 = bc4_in
  end subroutine

  subroutine fbi_init2(sou_nx_in, sou_ox_in, sou_dx_in, sou_z_in, rec_nx_in, rec_ox_in, rec_dx_in, rec_z_in) ! Copying variables 2
    integer                             :: sou_nx_in, sou_ox_in, sou_dx_in, sou_z_in
    integer                             :: rec_nx_in, rec_ox_in, rec_dx_in, rec_z_in
    sou_nx = sou_nx_in
    sou_ox = sou_ox_in
    sou_dx = sou_dx_in
    sou_z = sou_z_in
    rec_nx = rec_nx_in
    rec_ox = rec_ox_in
    rec_dx = rec_dx_in
    rec_z = rec_z_in
  end subroutine
   !!! Yi's change
  subroutine fbi_init3(nt_in, dt_in, wfld_j_in, nlag_in, olag_in, lag_type_in, geom_type_in, sou_ghost_in, rec_ghost_in) ! Copying variables 3
    integer                             :: nt_in, wfld_j_in, nlag_in, olag_in, lag_type_in, geom_type_in
    real                                :: dt_in
    logical                             :: sou_ghost_in, rec_ghost_in
    real				:: w0_in
    nt = nt_in
    wfld_j = wfld_j_in
    dt = dt_in
    nlag = nlag_in
    olag = olag_in
    lag_type = lag_type_in
    geom_type = geom_type_in
    sou_ghost = sou_ghost_in
    rec_ghost = rec_ghost_in
  end subroutine
  !!! Yi's change
  subroutine fbi_init4(w0_in, pw1_in, pw2_in, pw3_in, pw4_in)
     real	::w0_in, pw1_in, pw2_in, pw3_in, pw4_in

     w0 = w0_in
     pw1 = pw1_in 
     pw2 = pw2_in 
     pw3 = pw3_in 
     pw4 = pw4_in  




  end subroutine
!!! Yi's change
  subroutine fbi_alloc(wavelet_in) ! Allocations
    real, dimension(nt)                  :: wavelet_in

    nt2 = (nt-1)*wfld_j+1
    dtw = dt / wfld_j

    call mem_alloc(wavelet, nt)
    call mem_alloc(vel, n1, n2)
    call mem_alloc(vel_mult, n1, n2)
    call mem_alloc(veldt2, n1, n2)
    call mem_alloc(vwt, n1, n2)
    call mem_alloc(wt, n1, n2)
    call mem_alloc(temp1, n1, n2, nt)
    call mem_alloc(temp2, n1, n2, nt)
!!! Yi's change:
    call mem_alloc(bq, n1, n2)
    call mem_alloc(vel2dt, n1, n2)
    call mem_alloc(eta, n1, n2)
    call mem_alloc(tau, n1, n2)
    call mem_alloc(gama, n1, n2)
    call mem_alloc(gama_mean,1)
    wavelet = wavelet_in

    call sscale_init(n1, n2, nt, dtw, veldt2, wt)
    call prop_init(n1, n2, nt, wfld_j, bc1, bc2, bc3, bc4, d1, d2, veldt2, vwt, wt, vel2dt, gama, gama_mean, tau, eta, pw1, pw2, pw3, pw4)   !!! Yi's change
    call scat_init(n1, n2, nt)
    call escats_init(n1, n2, nt, nlag, olag, lag_type)
    call escatr_init(n1, n2, nt, nlag, olag, lag_type)
    call escat_refl_init(n1, n2, nt, nlag, olag, lag_type)
    call secder_init(n1, n2, nt, dt)
    call qpertub_init(n1, n2, nt, dt, d1, d2, gama, gama_mean, tau, eta, vel, bq, w0) 

  end subroutine

  function model_update(vel_in, bq_in) result(stat)
    integer             :: stat
    real, dimension(:)  :: vel_in, bq_in
    call model_update2(vel_in, bq_in)
    stat=0
  end function

  subroutine model_update2(vel_in, bq_in) ! Copy velocity model and prepare boundary condition stuff
    real, dimension(n1, n2)              :: vel_in, bq_in
    real				 :: pi
    
    pi=3.1415926
    vel = 0.
    vwt = 0.
    wt = 0.
    bq= 0.
    vel = vel_in
    bq = bq_in
    call AbcWt(vel, vwt, wt, dtw, d1, d2, bc1, bc2, bc3, bc4)
    veldt2 = vel*vel*dtw*dtw
    vel2dt=vel*vel*dtw
    gama=1/pi*atan(1/bq)
    gama_mean(1)=sum(gama)/n1/n2
    eta=-(vel**(2*gama))*(w0**(-2*gama))*cos(pi*gama)
    tau=-(vel**(2*gama-1))*(w0**(-2*gama))*sin(pi*gama)

  end subroutine

  function L_nlop(adj, add, qcomp, model, data) result(stat) ! Nonlinear operator fuction
    integer             :: stat
    logical, intent(in) :: adj, add , qcomp
    real, dimension(:)  :: model, data
    call L_nlop2(adj, add, qcomp, model, data)
    stat=0
  end function

  function L_lop(adj, add, qcomp, model, data) result(stat) ! Born operator fuction
    integer             :: stat 
    logical, intent(in) :: adj, add , qcomp
    real, dimension(:)  :: model, data
    call L_lop2(adj, add, qcomp, model, data)
    stat=0
  end function

  function T_lop(adj, add, qcomp, model, data, refl) result(stat) ! Tomographic operator fuction
    optional            :: refl
    integer             :: stat 
    logical, intent(in) :: adj, add , qcomp
    real, dimension(:)  :: model, data, refl
    if(.not. present(refl)) call erexit("optional parameter refl is required")
    call T_lop2(adj, add, qcomp, model, data, refl)
    stat=0
  end function

  function W_lop(adj, add, qcomp, model, data, dobs) result(stat) ! WEMVA operator fuction
    optional            :: dobs
    integer             :: stat 
    logical, intent(in) :: adj, add, qcomp
    real, dimension(:)  :: model, data, dobs
    if(.not. present(dobs)) call erexit("optional parameter dobs is required")
    call W_lop2(adj, add, qcomp, model, data, dobs)
    stat=0
  end function

  function M_lop(adj, add, qcomp, model, data, refl_mult) result(stat) ! Multiscattering operator fuction
    optional            :: refl_mult
    integer             :: stat 
    logical, intent(in) :: adj, add , qcomp
    real, dimension(:)  :: model, data, refl_mult
    if(.not. present(refl_mult)) call erexit("optional parameter refl_mult is required")
    call M_lop2(adj, add, qcomp, model, data, refl_mult)
    stat=0
  end function

  subroutine L_nlop2(adj, add, qcomp, model, data) ! Nonlinear operator: source <=> full nonlinear data (equation 9)
    logical, intent(in)                  :: adj, add, qcomp
    real, dimension(nt, rec_nx, sou_nx)  :: model
    real, dimension(nt, rec_nx, sou_nx)  :: data
    if(adj) then ! Adjoint: full nonlinear data => source
      if(.not. add) model = 0.
      do isou=1,sou_nx
        sou_x = (isou-1)*sou_dx + sou_ox
        off_x = 0
        if(geom_type .eq. 2) off_x = sou_x
        temp1 = 0.
        if(rec_ghost) then ! K operator
          do irec=1,rec_nx
            rec_x = (irec-1)*rec_dx + rec_ox + off_x
            temp1(rec_z,rec_x,:) = data(:,irec,isou)
            temp1(rec_z+1,rec_x,:) = -data(:,irec,isou)
          end do
        else
          do irec=1,rec_nx
            rec_x = (irec-1)*rec_dx + rec_ox + off_x
            temp1(rec_z,rec_x,:) = data(:,irec,isou)
          end do
        end if
        call prop_op2(.true., .false., qcomp, temp2, temp1) ! LG*L* operator
        call sscale_op2(.true., .false., temp1, temp2) ! S* operator
        if(exist_file("wflds0") .and. isou .eq. 1) then
          do it=1,nt
            call sep_write(temp1(:,:,it), "wflds0")
          end do
        end if
        if(sou_ghost) then ! K* operator
          do irec=1,rec_nx
            rec_x = (irec-1)*rec_dx + rec_ox + off_x
            model(:,irec,isou) = model(:,irec,isou) + temp1(sou_z,rec_x,:)
            model(:,irec,isou) = model(:,irec,isou) - temp1(sou_z+1,rec_x,:)
          end do
        else
          do irec=1,rec_nx
            rec_x = (irec-1)*rec_dx + rec_ox + off_x
            model(:,irec,isou) = model(:,irec,isou) + temp1(sou_z,rec_x,:)
          end do
        end if
      end do
    else ! Forward: source => full nonlinear data
      if(.not. add) data = 0.
      do isou=1,sou_nx
        sou_x = (isou-1)*sou_dx + sou_ox
        off_x = 0
        if(geom_type .eq. 2) off_x = sou_x
        temp1 = 0.
        if(sou_ghost) then ! K operator
          do irec=1,rec_nx
            rec_x = (irec-1)*rec_dx + rec_ox + off_x
            temp1(sou_z,rec_x,:) = model(:,irec,isou)
            temp1(sou_z+1,rec_x,:) = -model(:,irec,isou)
          end do
        else
          do irec=1,rec_nx
            rec_x = (irec-1)*rec_dx + rec_ox + off_x
            temp1(sou_z,rec_x,:) = model(:,irec,isou)
          end do
        end if
        call sscale_op2(.false., .false., temp1, temp2) ! S operator
        call prop_op2(.false., .false., qcomp, temp2, temp1) ! LGL* operator
        if(exist_file("wflds0") .and. isou .eq. 1) then
          do it=1,nt
            call sep_write(temp1(:,:,it), "wflds0")
          end do
        end if
        if(rec_ghost) then ! K* operator
          do irec=1,rec_nx
            rec_x = (irec-1)*rec_dx + rec_ox + off_x
            data(:,irec,isou) = data(:,irec,isou) + temp1(rec_z,rec_x,:)
            data(:,irec,isou) = data(:,irec,isou) - temp1(rec_z+1,rec_x,:)
          end do
        else
          do irec=1,rec_nx
            rec_x = (irec-1)*rec_dx + rec_ox + off_x
            data(:,irec,isou) = data(:,irec,isou) + temp1(rec_z,rec_x,:)
          end do
        end if
      end do
    end if
  end subroutine

  subroutine L_lop2(adj, add, qcomp, model, data) ! Born operator: perturbation <=> First order scattered data (i.e. data due to perturbation) (equation 22)
    logical, intent(in)                  :: adj, add, qcomp
    real, dimension(n1, n2, nlag)          :: model
    real, dimension(nt, rec_nx, sou_nx)  :: data
    if(adj) then ! Adjoint: First order scattered data => perturbation
      call mem_alloc(wfld1, n1, n2, nt)
      if(.not. add) model = 0.
      do isou=1,sou_nx
        ! Precompute the u_s0 wavefield using the wavelet
        sou_x = (isou-1)*sou_dx + sou_ox
        off_x = 0
        if(geom_type .eq. 2) off_x = sou_x
        temp1 = 0.
        if(sou_ghost) then ! K operator!!!Yi: padding
          temp1(sou_z,sou_x,:) = wavelet
          temp1(sou_z+1,sou_x,:) = -wavelet
        else
          temp1(sou_z,sou_x,:) = wavelet
        end if
        call sscale_op2(.false., .false., temp1, temp2) ! S operator !!! Yi: scaling
        call prop_op2(.false., .false., qcomp, temp2, wfld1) ! LGL* operator

        if(exist_file("wflds0") .and. isou .eq. 1) then
          do it=1,nt
            call sep_write(wfld1(:,:,it), "wflds0")
          end do
        end if

        ! operator starts here
        temp1 = 0.
        if(rec_ghost) then ! K operator
          do irec=1,rec_nx
            rec_x = (irec-1)*rec_dx + rec_ox + off_x
            temp1(rec_z,rec_x,:) = data(:,irec,isou)
            temp1(rec_z+1,rec_x,:) = -data(:,irec,isou)
          end do
        else
          do irec=1,rec_nx
            rec_x = (irec-1)*rec_dx + rec_ox + off_x
            temp1(rec_z,rec_x,:) = data(:,irec,isou)
          end do
        end if
        call prop_op2(.true., .false., qcomp, temp2, temp1) ! LG*L* operator
        call sscale_op2(.true., .false., temp1, temp2) ! S* operator
        call secder_op2(.true., .false., temp2, temp1) ! T* operator

        if(exist_file("wfldr0") .and. isou .eq. 1) then
          do it=1,nt
            call sep_write(temp2(:,:,it), "wfldr0")
          end do
        end if

        call escats_op2(.true., .true., model, temp2, wfld1) ! (U^_s0)* operator
      end do
      call mem_dealloc(wfld1)
    else ! Forward: perturbation => First order scattered data
      if(.not. add) data = 0.
      do isou=1,sou_nx
        ! Precompute the u_s0 wavefield using the wavelet; 
	! source side wavefield 
        sou_x = (isou-1)*sou_dx + sou_ox
        off_x = 0
        if(geom_type .eq. 2) off_x = sou_x
        temp1 = 0.
        if(sou_ghost) then ! K operator
          temp1(sou_z,sou_x,:) = wavelet
          temp1(sou_z+1,sou_x,:) = -wavelet
        else
          temp1(sou_z,sou_x,:) = wavelet
        end if
        call sscale_op2(.false., .false., temp1, temp2) ! S operator ! Yi: multiply vel^2
        call prop_op2(.false., .false., .false., temp2, temp1) ! LGL* operator  ! Yi: spactial direvative

        if(exist_file("wflds0") .and. isou .eq. 1) then
          do it=1,nt
            call sep_write(temp1(:,:,it), "wflds0")
          end do
        end if

        ! operator starts here
        call escats_op2(.false., .false., model, temp2, temp1) ! U^_s0 operator;  ! Yi: extended model x wavefield
        call secder_op2(.false., .false., temp2, temp1) ! T operator  ! Yi: time direvitave
        call sscale_op2(.false., .false., temp1, temp2) ! S operator  ! Yi multiply vel^2
        call prop_op2(.false., .false., .false., temp2, temp1) ! LGL* operator  ! spatial direvative

        if(exist_file("wflds1") .and. isou .eq. 1) then
          do it=1,nt
            call sep_write(temp1(:,:,it), "wflds1")
          end do
        end if

        if(rec_ghost) then ! K* operator
          do irec=1,rec_nx
            rec_x = (irec-1)*rec_dx + rec_ox + off_x
            data(:,irec,isou) = data(:,irec,isou) + temp1(rec_z,rec_x,:)
            data(:,irec,isou) = data(:,irec,isou) - temp1(rec_z+1,rec_x,:)
          end do
        else
          do irec=1,rec_nx
            rec_x = (irec-1)*rec_dx + rec_ox + off_x
            data(:,irec,isou) = data(:,irec,isou) + temp1(rec_z,rec_x,:)
          end do
        end if
      end do
    end if
  end subroutine

  subroutine T_lop2(adj, add, qcomp, model, data, refl) ! Tomographic operator: background change <=> Second order scattered data (i.e. data due to transmission changes), needs perturbation
    optional                             :: refl
    logical, intent(in)                  :: adj, add, qcomp
    real, dimension(n1, n2)              :: model
    real, dimension(nt, rec_nx, sou_nx)  :: data
    real, dimension(n1, n2, nlag)        :: refl
    if(.not. present(refl)) call erexit("optional parameter refl is required")
    call mem_alloc(wfld1, n1, n2, nt)
    if(adj) then ! Adjoint: Second order scattered data => background change
      call mem_alloc(wfld2, n1, n2, nt)
      if(.not. add) model = 0.
      do isou=1,sou_nx
        ! Precompute the u_s0 wavefield using the wavelet
        sou_x = (isou-1)*sou_dx + sou_ox
        off_x = 0
        if(geom_type .eq. 2) off_x = sou_x
        temp1 = 0.
        if(sou_ghost) then ! K operator
          temp1(sou_z,sou_x,:) = wavelet
          temp1(sou_z+1,sou_x,:) = -wavelet
        else
          temp1(sou_z,sou_x,:) = wavelet
        end if
        call sscale_op2(.false., .false., temp1, temp2) ! S operator
        call prop_op2(.false., .false., qcomp, temp2, wfld1) ! LGL* operator

        if(exist_file("wflds0") .and. isou .eq. 1) then
          do it=1,nt
            call sep_write(wfld1(:,:,it), "wflds0")
          end do
        end if

        ! Compute the u_r0 wavefield using the second order scattered data (this is a shared part of both halves of the operator)
        temp2 = 0.
        if(rec_ghost) then ! K operator
          do irec=1,rec_nx
            rec_x = (irec-1)*rec_dx + rec_ox + off_x
            temp2(rec_z,rec_x,:) = data(:,irec,isou)
            temp2(rec_z+1,rec_x,:) = -data(:,irec,isou)
          end do
        else
          do irec=1,rec_nx
            rec_x = (irec-1)*rec_dx + rec_ox + off_x
            temp2(rec_z,rec_x,:) = data(:,irec,isou)
          end do
        end if
        call prop_op2(.true., .false., qcomp, temp1, temp2) ! LG*L* operator
        call sscale_op2(.true., .false., temp2, temp1) ! S* operator
        call secder_op2(.true., .false., wfld2, temp2) ! T* operator

        if(exist_file("wfldr0") .and. isou .eq. 1) then
          do it=1,nt
            call sep_write(wfld2(:,:,it), "wfldr0")
          end do
        end if

        call escat_refl_op2(.true., .false., temp2, wfld2, refl) ! R* operator
        call prop_op2(.true., .false., qcomp, temp1, temp2) ! LG*L* operator
        call sscale_op2(.true., .false., temp2, temp1) ! S* operator
        call secder_op2(.true., .false., temp1, temp2) ! T* operator
        call scat_op2(.true., .true., model, temp1, wfld1) ! (U_s0)* operator

        ! Precompute the u_ds wavefield using u_s0 wavefield then do the second half of the operator
        call escat_refl_op2(.false., .false., wfld1, temp2, refl) ! R operator
        call secder_op2(.false., .false., temp2, temp1) ! T operator
        call sscale_op2(.false., .false., temp1, temp2) ! S operator
        call prop_op2(.false., .false., qcomp, temp2, temp1) ! LGL* operator
        call scat_op2(.true., .true., model, temp1, wfld2) ! (U_ds)* operator
      end do
      call mem_dealloc(wfld2)
    else ! Forward: background change => Second order scattered data
      if(.not. add) data = 0.
      do isou=1,sou_nx
        ! Precompute the u_s0 wavefield using the wavelet
        sou_x = (isou-1)*sou_dx + sou_ox
        off_x = 0
        if(geom_type .eq. 2) off_x = sou_x
        temp1 = 0.
        if(sou_ghost) then ! K operator
          temp1(sou_z,sou_x,:) = wavelet
          temp1(sou_z+1,sou_x,:) = -wavelet
        else
          temp1(sou_z,sou_x,:) = wavelet
        end if
        call sscale_op2(.false., .false., temp1, temp2) ! S operator
        call prop_op2(.false., .false., qcomp, temp2, wfld1) ! LGL* operator

        if(exist_file("wflds0") .and. isou .eq. 1) then
          do it=1,nt
            call sep_write(wfld1(:,:,it), "wflds0")
          end do
        end if

        ! Precompute the u_ds wavefield using u_s0 wavefield then do the first half of the operator
        call escat_refl_op2(.false., .false., wfld1, temp1, refl) ! R operator
        call secder_op2(.false., .false., temp1, temp2) ! T operator
        call sscale_op2(.false., .false., temp2, temp1) ! S operator
        call prop_op2(.false., .false., qcomp, temp1, temp2) ! LGL* operator
        call scat_op2(.false., .false., model, temp1, temp2) ! U_ds operator
        call secder_op2(.false., .false., temp1, temp2) ! T operator
        call sscale_op2(.false., .false., temp2, temp1) ! S operator
        call prop_op2(.false., .false., qcomp, temp1, temp2) ! LGL* operator
        if(rec_ghost) then ! K* operator
          do irec=1,rec_nx
            rec_x = (irec-1)*rec_dx + rec_ox + off_x
            data(:,irec,isou) = data(:,irec,isou) + temp2(rec_z,rec_x,:)
            data(:,irec,isou) = data(:,irec,isou) - temp2(rec_z+1,rec_x,:)
          end do
        else
          do irec=1,rec_nx
            rec_x = (irec-1)*rec_dx + rec_ox + off_x
            data(:,irec,isou) = data(:,irec,isou) + temp2(rec_z,rec_x,:)
          end do
        end if

        ! second half of operator starts here
        call scat_op2(.false., .false., model, temp1, wfld1) ! U_s0 operator
        call secder_op2(.false., .false., temp1, temp2) ! T operator
        call sscale_op2(.false., .false., temp2, temp1) ! S operator
        call prop_op2(.false., .false., qcomp, temp1, temp2) ! LGL* operator
        call escat_refl_op2(.false., .false., temp2, temp1, refl) ! R operator
        call secder_op2(.false., .false., temp1, temp2) ! T operator
        call sscale_op2(.false., .false., temp2, temp1) ! S operator
        call prop_op2(.false., .false., qcomp, temp1, temp2) ! LGL* operator
        if(rec_ghost) then ! K* operator
          do irec=1,rec_nx
            rec_x = (irec-1)*rec_dx + rec_ox + off_x
            data(:,irec,isou) = data(:,irec,isou) + temp2(rec_z,rec_x,:)
            data(:,irec,isou) = data(:,irec,isou) - temp2(rec_z+1,rec_x,:)
          end do
        else
          do irec=1,rec_nx
            rec_x = (irec-1)*rec_dx + rec_ox + off_x
            data(:,irec,isou) = data(:,irec,isou) + temp2(rec_z,rec_x,:)
          end do
        end if
      end do
    end if
    call mem_dealloc(wfld1)
  end subroutine

  subroutine W_lop2(adj, add, qcomp, model, data, dobs) ! WEMVA operator: background change <=> Perturbation change, needs first order scattered data
    optional                             :: dobs
    logical, intent(in)                  :: adj, add, qcomp
    real, dimension(n1, n2)              :: model
    real, dimension(n1, n2, nlag)        :: data
    real, dimension(nt, rec_nx, sou_nx)  :: dobs
    if(.not. present(dobs)) call erexit("optional parameter dobs is required")
    call mem_alloc(wfld1, n1, n2, nt)
    call mem_alloc(wfld2, n1, n2, nt)
    if(adj) then ! Adjoint: Perturbation change => background change
      if(.not. add) model = 0.
      do isou=1,sou_nx
        ! Precompute the u_s0 wavefield using the wavelet
        sou_x = (isou-1)*sou_dx + sou_ox
        off_x = 0
        if(geom_type .eq. 2) off_x = sou_x
        temp1 = 0.
        if(sou_ghost) then ! K operator
          temp1(sou_z,sou_x,:) = wavelet
          temp1(sou_z+1,sou_x,:) = -wavelet
        else
          temp1(sou_z,sou_x,:) = wavelet
        end if
        call sscale_op2(.false., .false., temp1, temp2) ! S operator
        call prop_op2(.false., .false., qcomp, temp2, wfld1) ! LGL* operator

        if(exist_file("wflds0") .and. isou .eq. 1) then
          do it=1,nt
            call sep_write(wfld1(:,:,it), "wflds0")
          end do
        end if

        ! Precompute the u_r0 wavefield using the first order scattered data
        temp1 = 0.
        if(rec_ghost) then ! K operator
          do irec=1,rec_nx
            rec_x = (irec-1)*rec_dx + rec_ox + off_x
            temp1(rec_z,rec_x,:) = dobs(:,irec,isou)
            temp1(rec_z+1,rec_x,:) = -dobs(:,irec,isou)
          end do
        else
          do irec=1,rec_nx
            rec_x = (irec-1)*rec_dx + rec_ox + off_x
            temp1(rec_z,rec_x,:) = dobs(:,irec,isou)
          end do
        end if
        call prop_op2(.true., .false., qcomp, temp2, temp1) ! LG*L* operator
        call sscale_op2(.true., .false., temp1, temp2) ! S* operator
        call secder_op2(.true., .false., wfld2, temp1) ! T* operator

        if(exist_file("wfldr0") .and. isou .eq. 1) then
          do it=1,nt
            call sep_write(wfld2(:,:,it), "wfldr0")
          end do
        end if

        ! operator starts here
        call escatr_op2(.false., .false., data, temp2, wfld2) ! U^_r0 operator
        call prop_op2(.true., .false., qcomp, temp1, temp2) ! LG*L* operator
        call sscale_op2(.true., .false., temp2, temp1) ! S* operator
        call secder_op2(.true., .false., temp1, temp2) ! T* operator
	!call qpertub_op2(.true., .false., temp1, temp2) ! Q* operator
	write(0,*) "temp1, temp2", sum(temp1), sum(temp2)
        call scat_op2(.true., .true., model, temp1, wfld1) ! (U_s0)* operator

        ! second half of operator starts here
        call escats_op2(.false., .false., data, temp2, wfld1) ! U^_s0 operator
        call secder_op2(.false., .false., temp2, temp1) ! T operator
	!call qpertub_op2(.false., .false., temp2, temp1) ! Q operator
        call sscale_op2(.false., .false., temp1, temp2) ! S operator
        call prop_op2(.false., .false., qcomp, temp2, temp1) ! LGL* operator
        call scat_op2(.true., .true., model, temp1, wfld2) ! (U_r0)* operator
      end do
    else ! Forward: background change => Perturbation change
      if(.not. add) data = 0.
      do isou=1,sou_nx
        ! Precompute the u_s0 wavefield using the wavelet
        sou_x = (isou-1)*sou_dx + sou_ox
        off_x = 0
        if(geom_type .eq. 2) off_x = sou_x
        temp1 = 0.
        if(sou_ghost) then ! K operator
          temp1(sou_z,sou_x,:) = wavelet
          temp1(sou_z+1,sou_x,:) = -wavelet
        else
          temp1(sou_z,sou_x,:) = wavelet
        end if
        call sscale_op2(.false., .false., temp1, temp2) ! S operator
        call prop_op2(.false., .false., qcomp, temp2, wfld1) ! LGL* operator

        if(exist_file("wflds0") .and. isou .eq. 1) then
          do it=1,nt
            call sep_write(wfld1(:,:,it), "wflds0")
          end do
        end if

        ! Precompute the u_r0 wavefield using the first order scattered data
        temp1 = 0.
        if(rec_ghost) then ! K operator
          do irec=1,rec_nx
            rec_x = (irec-1)*rec_dx + rec_ox + off_x
            temp1(rec_z,rec_x,:) = dobs(:,irec,isou)
            temp1(rec_z+1,rec_x,:) = -dobs(:,irec,isou)
          end do
        else
          do irec=1,rec_nx
            rec_x = (irec-1)*rec_dx + rec_ox + off_x
            temp1(rec_z,rec_x,:) = dobs(:,irec,isou)
          end do
        end if
        call prop_op2(.true., .false., qcomp, temp2, temp1) ! LG*L* operator
        call sscale_op2(.true., .false., temp1, temp2) ! S* operator
        call secder_op2(.true., .false., wfld2, temp1) ! T* operator

        if(exist_file("wfldr0") .and. isou .eq. 1) then
          do it=1,nt
            call sep_write(wfld2(:,:,it), "wfldr0")
          end do
        end if

        ! operator starts here
        call scat_op2(.false., .false., model, temp1, wfld2) ! U_r0 operator
        call prop_op2(.true., .false., qcomp, temp2, temp1) ! LG*L* operator
        call sscale_op2(.true., .false., temp1, temp2) ! S* operator
        !call secder_op2(.true., .false., temp2, temp1) ! T* operator
        call qpertub_op2(.true., .false., temp2, temp1) ! Q* operator 
        call escats_op2(.true., .true., data, temp2, wfld1) ! (U^_s0)* operator

        ! second half of operator starts here
        call scat_op2(.false., .false., model, temp1, wfld1) ! U_s0 operator
       ! call secder_op2(.false., .false., temp1, temp2) ! T operator
        call qpertub_op2(.false., .false., temp1, temp2) ! Q operator
        call sscale_op2(.false., .false., temp2, temp1) ! S operator
        call prop_op2(.false., .false., qcomp, temp1, temp2) ! LGL* operator
        call escatr_op2(.true., .true., data, temp1, wfld2) ! (U^_r0)* operator
      end do
    end if
    call mem_dealloc(wfld1)
    call mem_dealloc(wfld2)
  end subroutine

  subroutine M_lop2(adj, add, qcomp, model, data, refl_mult) ! perturbation <=> Multiscattered data, needs multiscattering reflectivity
    optional                             :: refl_mult
    logical, intent(in)                  :: adj, add, qcomp
    real, dimension(n1, n2)              :: model
    real, dimension(nt, rec_nx, sou_nx)  :: data
    real, dimension(n1, n2, nlag)        :: refl_mult
    if(.not. present(refl_mult)) call erexit("optional parameter refl_mult is required")
    if(adj) then ! Adjoint: Multiscattered data => perturbation
      call erexit("Adjoint multiscattering is not implemented yet")
    else ! Forward: perturbation => Multiscattered data
      if(.not. add) data = 0.
      ! Compute the multiscattering velocity (using only the zero lag of refl_mult, which is in units of slowness squared), conversion is to match the units
      vel_mult = 1./(vel*vel)
      vel_mult = vel_mult + refl_mult(:,:,1-olag)
      vel_mult = 1./sqrt(vel_mult)

      do isou=1,sou_nx
        ! Precompute the u_s0 wavefield using the wavelet
        sou_x = (isou-1)*sou_dx + sou_ox
        off_x = 0
        if(geom_type .eq. 2) off_x = sou_x
        temp1 = 0.
        if(sou_ghost) then ! K operator
          temp1(sou_z,sou_x,:) = wavelet
          temp1(sou_z+1,sou_x,:) = -wavelet
        else
          temp1(sou_z,sou_x,:) = wavelet
        end if
        call sscale_op2(.false., .false., temp1, temp2) ! S operator
        call prop_op2(.false., .false., qcomp, temp2, temp1) ! LGL* operator

        if(exist_file("wflds0") .and. isou .eq. 1) then
          do it=1,nt
            call sep_write(temp1(:,:,it), "wflds0")
          end do
        end if

        ! Use vel for the background wavefield
        call model_update2(vel_mult, bq)

        ! operator starts here
        call escats_op2(.false., .false., model, temp2, temp1) ! U^_s0 operator
        call secder_op2(.false., .false., temp2, temp1) ! T operator
        call sscale_op2(.false., .false., temp1, temp2) ! S operator
        call prop_op2(.false., .false., qcomp, temp2, temp1) ! LGL* operator

        if(exist_file("wflds1") .and. isou .eq. 1) then
          do it=1,nt
            call sep_write(temp1(:,:,it), "wflds1")
          end do
        end if

        if(rec_ghost) then ! K* operator
          do irec=1,rec_nx
            rec_x = (irec-1)*rec_dx + rec_ox + off_x
            data(:,irec,isou) = data(:,irec,isou) + temp1(rec_z,rec_x,:)
            data(:,irec,isou) = data(:,irec,isou) - temp1(rec_z+1,rec_x,:)
          end do
        else
          do irec=1,rec_nx
            rec_x = (irec-1)*rec_dx + rec_ox + off_x
            data(:,irec,isou) = data(:,irec,isou) + temp1(rec_z,rec_x,:)
          end do
        end if

        ! Reset to the original velocity model
        call model_update2(vel, bq)

      end do
    end if
  end subroutine

end module 
