!!! search for alph: <grdo.H(Previous Q model) nsrch=[3] alphP=alphP.H alphO=alphO.H fobjP=fobjP.H(current) fobjO=fobjO.H(previous) fobj=fobj.H(output) srch=srch.H >grdp.H(Updated Q model)

!!! alfa_min=1/2*(a1^2f2+a2^2f3+a3^2f1-a1^2f3-a2^2f1-a3^2f2)/(a1f2+a2f3+a3f1-a1f3-a2f1-a3f2)
!!! a*a(i)^2+b*a(i)+c=f(i)
program main
  use sep
  use util_axisIO
  implicit none


    integer			  :: nsrc
    integer			  :: n1, n2, n3, i1, i2, i3
    real 			  :: sfac, norm
    real, allocatable		  :: fp(:), fo(:),  fobj(:)
    real, allocatable		  :: alphP(:),alphO(:), grdo(:,:,:), grdp(:,:,:), srch(:,:,:)
    real	                  :: fopt
    integer			  :: iopt, isrc
    real			  :: qmin, qmax
    real			  :: f1, f2, f3, a1, a2, a3, a, b, c
    type(myaxis)  		  :: axis1
 
    call sep_init()

    call from_param("nsrch", nsrc, 2)
    call from_param('qmax', qmax, 5.0)
    call from_param('qmin', qmin, 2.3)
    call from_history("n1", n1)
    call from_history("n2", n2)
    call from_history("n3", n3)

    allocate(fp(2), fo(1), alphP(1),alphO(1), grdo(n1, n2, n3), grdp(n1, n2, n3), srch(n1, n2, n3), fobj(1) )

    call sep_read(fp, "fobjP")
    call sep_read(fo, "fobjO")
    call sep_read(alphO, "alphO")
    call sep_read(srch, "srch")
    call sep_read(grdo)

    sfac = 0.5*(nsrc+1)
    norm = maxval(abs(srch))
    srch = srch/norm
!   find the minimum one over fp(isrc)
!   --------------------
    a1=alphO(1); f1=fo(1)
    a2=2*alphO(1); f2=fp(1)
    a3=3*alphO(2); f3=fp(2)
    a=((f3-f1)*(a3-a1)-(f2-f1)*(a2-a1))/(a3-a2)
    b=(f2-f1)/(a2-a1)-a*(a2+a1)
    c=f1-a*a1**2+b*a1
    alphP(1)=-b/2/a
    if (alphP(1)<=0) then
      if (f1<=f2<=f3) then
	alphP(1)=a1/2
      else if (f1<=f3<=f2) then
	alphP(1)=a1/2
      else if (f2<=f1<=f3) then
	alphP(1)=a2
      else if (f2<=f3<=f1) then
	alphP(1)=a2
      else if (f3<=f1<=f2) then
	alphP(1)=a3
      else if (f3<=f2<=f1) then
	alphP(1)=a3
      end if
    end if
    fobj=alphP(1)**2*a+alphP(1)*b+c
   ! alphP(1)=1/2*(a(1)**2*fp(2)+a(2)**2*fp(3)+a(3)**2*fp(1)-a(1)**2*fp(3)-a(2)**2*fp(1)-a(3)**2*fp(2))/(a(1)*fp(2)+a(2)*fp(3)+a(3)*fp(1)-a(1)*fp(3)-a(2)*fp(1)-a(3)*fp(2))
      grdp=grdo+alphP(1)*srch
!   compare with the current objective function value
    write(0,*) "alpha_new, alpha_old, fobj_new, fobj_old", alphP(1), alphO(1),fobj, fo(1)

   !!! hard boundary for q value
     do i1=1, n1
     do i2=1, n2
       do i3=1, n3
	 if (grdp(i1, i2, i3) .gt.qmax) then
		grdp(i1, i2, i3)=qmax
	  else if (grdp(i1, i2, i3) .lt. qmin) then
		grdp(i1, i2, i3)=qmin
	 end if
       end do 
     end do
   end do
   !!! output: grdp, alph, fobj 

  call set_axis(axis1,1,1.0,0.0," ")
  call houtaxis(axis1,1,'fobj')
  call houtaxis(axis1,1,'alphP' )

  call sep_write(fobj,'fobj')
  call sep_write(alphP, 'alphP')
  call sep_write(grdp)

  deallocate(fp, fo, alphP,alphO, grdo, grdp, srch, fobj )

  call sep_close()

end program
