!!! Yi's change:
!!! 1. define
!!! 2. prop_init
!!! 3. prop_op
!!!  1. fft-> filter-> ifft for spectral ratio
!!!  2. multiply coef for p2 using the spectral ratio
!!! Note: To speed up Sceodo spectral, I did the following change
!!!  1. Parellizing fftw: drop 1/2
!!!  2. reduce two FFT: drop 1/2
module prop_mod

  use mem_mod
  use prop_base
  use  base_fftwv3_mod
  implicit none

  integer, private                            :: n1, n2, nt, wfld_j 
  integer, private                            :: bc1, bc2, bc3, bc4, fat
  integer, private                            :: iz, ix, it, iw
  real, private                               :: stencil0, c
  real, dimension(5), private                 :: stencilz, stencilx
  real, dimension(:), allocatable, private    :: lwt1, lwt2, lwt3, lwt4
  real, dimension(:,:), pointer, private      :: veldt2, vwt, wt
  real, dimension(:,:), allocatable, private  :: p0, p1, p2
  real, private  			      :: pw1, pw2, pw3, pw4, d1, d2   !!! Yi's change
  real, dimension(:), private, pointer	      :: gama_mean !!! Yi's change
  real, dimension(:,:), pointer, private      :: gama, tau, eta, vel2dt !!! Yi's change


  contains

  subroutine prop_init(n1_in, n2_in, nt_in, wfld_j_in, bc1_in, bc2_in, bc3_in, bc4_in, d1_in, d2_in, veldt2_in, vwt_in, wt_in, vel2dt_in, gama_in, gama_mean_in, tau_in, eta_in, pw1_in, pw2_in, pw3_in, pw4_in)
    integer                        :: n1_in, n2_in, nt_in, wfld_j_in, bc1_in, bc2_in, bc3_in, bc4_in
    real                           :: d1_in, d2_in
    real, dimension(:,:), target   :: veldt2_in, vwt_in, wt_in
    real      		           :: pw1_in, pw2_in, pw3_in, pw4_in  !!! Yi's change
    real, dimension(:),target     :: gama_mean_in !!! Yi's change
    real, dimension(:,:), target   :: gama_in, tau_in, eta_in, vel2dt_in !!! Yi's change

    n1 = n1_in
    n2 = n2_in
    nt = nt_in
    wfld_j = wfld_j_in
    bc1 = bc1_in
    bc2 = bc2_in
    bc3 = bc3_in
    bc4 = bc4_in

    veldt2 => veldt2_in
    vwt => vwt_in
    wt => wt_in
!!! Yi's change
     d1 = d1_in
     d2 = d2_in
     pw1 = pw1_in 
     pw2 = pw2_in 
     pw3 = pw3_in 
     pw4 = pw4_in  
     gama_mean=>gama_mean_in
     vel2dt => vel2dt_in
     tau => tau_in
     eta => eta_in
     gama => gama_in   

    fat = 5

    call mem_alloc(lwt1, wfld_j)
    call mem_alloc(lwt2, wfld_j)
    call mem_alloc(lwt3, wfld_j)
    call mem_alloc(lwt4, wfld_j)
    do iw=1,wfld_j
      lwt2(iw) = 1.*iw/wfld_j
      lwt4(iw) = 1.*(iw-1)/wfld_j
    end do
    lwt1 = 1. - lwt2
    lwt3 = 1. - lwt4
    c = sqrt(1.*wfld_j)
    lwt1 = lwt1 / c
    lwt2 = lwt2 / c
    lwt3 = lwt3 / c
    lwt4 = lwt4 / c

    stencilz(1)=3.333333333/(2.*d1_in*d1_in)
    stencilz(2)=-0.4761904762/(2.*d1_in*d1_in)
    stencilz(3)=0.0793650794/(2.*d1_in*d1_in)
    stencilz(4)=-0.0099206349/(2.*d1_in*d1_in)
    stencilz(5)=0.0006349206/(2.*d1_in*d1_in)

    stencilx(1)=3.333333333/(2.*d2_in*d2_in)
    stencilx(2)=-0.4761904762/(2.*d2_in*d2_in)
    stencilx(3)=0.0793650794/(2.*d2_in*d2_in)
    stencilx(4)=-0.0099206349/(2.*d2_in*d2_in)
    stencilx(5)=0.0006349206/(2.*d2_in*d2_in)

    stencil0=(stencilz(5)+stencilx(5))
    stencil0=stencil0+(stencilz(4)+stencilx(4))
    stencil0=stencil0+(stencilz(3)+stencilx(3))
    stencil0=stencil0+(stencilz(2)+stencilx(2))
    stencil0=stencil0+(stencilz(1)+stencilx(1))
    stencil0=-2.*stencil0

    if(.not. allocated(p0)) then
      allocate(p0(1-fat:n1+fat,1-fat:n2+fat))
      call mem_add_4(size(p0))
    end if
    if(.not. allocated(p1)) then
      allocate(p1(1-fat:n1+fat,1-fat:n2+fat))
      call mem_add_4(size(p1))
    end if
    if(.not. allocated(p2)) then
      allocate(p2(1-fat:n1+fat,1-fat:n2+fat))
      call mem_add_4(size(p2))
    end if

  end subroutine

  function prop_op(adj, add,qcomp, model, data) result(stat)
    logical,intent(in) :: adj, add, qcomp
    real,dimension(:)  :: model, data
    integer            :: stat
    call prop_op2(adj, add, qcomp, model, data)
    stat=0
  end function

  subroutine prop_op2(adj, add, qcomp, model, data)
    logical,intent(in)        :: adj, add , qcomp
    real, dimension(n1,n2,nt) :: model, data
    complex, dimension(n1,n2) :: ip2, ip1, ip0
    integer*8       :: plan_2d1F, plan_2d0F
    integer*8       :: plan_2dFNDI, plan_2dFDI, plan_2dFNHI, plan_2dFNLI
    integer*8       :: plan_2d2I
    integer*8       :: plan_2dFDF, plan_2dFHF, plan_2dFLF
    real, dimension(n1):: kz 
    real, dimension(n2):: kx 
    integer :: stat
    real, dimension(n1, n2):: k_img, oper_H, oper_L, oper_D
    complex, dimension(n1, n2):: pD, pH, pL, pDF,  pHF, pLF, pNF
    complex, dimension(n1, n2)::p1_FD, p1_FND, p1_FNH, p1_FNL
    p0 = 0.
    p1 = 0.
    p2 = 0.

!!! Yi's change: calulate oper_HLD

    call k_map(kx,n2,d2)
    call k_map(kz,n1,d1)
    do ix=1,n2
      do iz=1,n1
	 k_img(iz, ix) =sqrt(kx(ix)*kx(ix)+kz(iz)*kz(iz))
      end do
    end do
    oper_H =(k_img)**(2*gama_mean(1)+1)
    oper_L =(k_img)**(2*gama_mean(1)+2)
    oper_D =-k_img**2
    call sfftw_init_threads(stat);
    call sfftw_plan_with_nthreads(16);


write(0,*) "CHECK STAT",stat

    if(adj) then
      if (qcomp) then  !!! qcomp
	write(0,*) "qcomp in the adjoint"
	write(0,*) "eta, tau,gama, gama_mean",sum(eta)/size(eta), sum(tau)/size(tau),sum(gama)/size(gama),gama_mean
	write(0,*) "oper_D, oper_L, oper_H",sum(oper_D)/size(oper_D), sum(oper_L)/size(oper_L),sum(oper_H)/size(oper_H)

       call sfftw_dft_2dx_init(plan_2d2I, ip2, n1, n2, -1)
       call sfftw_dft_2dx_init(plan_2dFDF, pD, n1, n2, +1)
      call sfftw_dft_2dx_init(plan_2dFHF, pH, n1, n2, +1)
      call sfftw_dft_2dx_init(plan_2dFLF, pL, n1, n2, +1)
      if(.not. add) model = 0.
      do it=nt,2,-1
        do iw=1,wfld_j
          p2(1:n1,1:n2) = lwt3(iw)*data(:,:,it) + lwt4(iw)*data(:,:,it-1) + (2.-wt)*p1(1:n1,1:n2) + (wt-1.)*p0(1:n1,1:n2)
	!!! Yi's change
	!(1)
	  pD=veldt2*(1-wt)*p1(1:n1,1:n2)
	  pL=veldt2*eta*(1-wt)*p1(1:n1,1:n2)
	  pH=vel2dt*tau*(1-wt)*(p1(1:n1,1:n2)-p0(1:n1,1:n2))
	  

	!(2) boundary condition, no fat??????? 

	!!! FFT
	  call sfftw_dft_2dx_oper(plan_2dFDF, pD, n1, n2)
	  call sfftw_dft_2dx_oper(plan_2dFLF, pL, n1, n2)
	  call sfftw_dft_2dx_oper(plan_2dFHF, pH, n1, n2)

	 !!! oper
	pDF=oper_D*pD
	pLF=oper_L*pL
	pHF=-oper_H*pH
	pNF=pLF-pDF+pHF
	!! hamming
	do iz=1,n1
	  call hammingw1(pNF(iz,:), pw3, pw4)
	end do
	do ix=1,n2
	 call hammingw1(pNF(:,ix), pw1, pw2)
	end do	
	!! p2
	ip2=pDF+pNF


	!!! ifft
	call sfftw_dft_2dx_oper(plan_2d2I, ip2, n1, n2)
	p2(1:n1,1:n2)= p2(1:n1,1:n2)+real(ip2)


          p0(1:n1,1:n2) = wt*vwt*p1(1:n1,1:n2)
          do ix=1,n2
            do iz=1,bc1
              p2(iz,ix) = p2(iz,ix) - p0(iz,ix)
              p2(iz+1,ix) = p2(iz+1,ix) + p0(iz,ix)    
            end do
            do iz=n1-bc3+1,n1
              p2(iz,ix) = p2(iz,ix) - p0(iz,ix)
              p2(iz-1,ix) = p2(iz-1,ix) + p0(iz,ix)
            end do
          end do
          do ix=1,bc2
            do iz=1,n1
              p2(iz,ix) = p2(iz,ix) - p0(iz,ix)
              p2(iz,ix+1) = p2(iz,ix+1) + p0(iz,ix)
            end do
          end do
          do ix=n2-bc4+1,n2
            do iz=1,n1
              p2(iz,ix) = p2(iz,ix) - p0(iz,ix)
              p2(iz,ix-1) = p2(iz,ix-1) + p0(iz,ix)
            end do
          end do


          model(:,:,it) = model(:,:,it) + lwt1(iw)*p2(1:n1,1:n2)
          model(:,:,it-1) = model(:,:,it-1) + lwt2(iw)*p2(1:n1,1:n2)
          p0 = p1
          p1 = p2
        end do
      end do
	write(0,*) "pD, pL, pH",sum(pD)/size(pD), sum(pL)/size(pL),sum(pH)/size(pH)
	write(0,*) "p1, wt, veldt2",sum(p1)/size(p1), sum(wt)/size(wt),sum(veldt2)/size(veldt2)
      else !!! not qcomp

	write(0,*) "no qcomp in adjoint"
	write(0,*) "eta, tau,gama, gama_mean",sum(eta)/size(eta), sum(tau)/size(tau),sum(gama)/size(gama),gama_mean
	write(0,*) "oper_D, oper_L, oper_H",sum(oper_D)/size(oper_D), sum(oper_L)/size(oper_L),sum(oper_H)/size(oper_H)
       call sfftw_dft_2dx_init(plan_2d2I, ip2, n1, n2, -1)
       call sfftw_dft_2dx_init(plan_2dFDF, pD, n1, n2, +1)
      call sfftw_dft_2dx_init(plan_2dFHF, pH, n1, n2, +1)
      call sfftw_dft_2dx_init(plan_2dFLF, pL, n1, n2, +1)
      if(.not. add) model = 0.
      do it=nt,2,-1
        do iw=1,wfld_j
          p2(1:n1,1:n2) = lwt3(iw)*data(:,:,it) + lwt4(iw)*data(:,:,it-1) + (2.-wt)*p1(1:n1,1:n2) + (wt-1.)*p0(1:n1,1:n2)
	!!! Yi's change
	!(1)
	  pL=veldt2*eta*(1-wt)*p1(1:n1,1:n2)
	  pH=vel2dt*tau*(1-wt)*(p1(1:n1,1:n2)-p0(1:n1,1:n2))
	  

	!(2) boundary condition, no fat??????? 

	!!! FFT
	  call sfftw_dft_2dx_oper(plan_2dFLF, pL, n1, n2)
	  call sfftw_dft_2dx_oper(plan_2dFHF, pH, n1, n2)


	!! p2
	ip2=oper_L*pL+oper_H*pH


	!!! ifft
	call sfftw_dft_2dx_oper(plan_2d2I, ip2, n1, n2)
	p2(1:n1,1:n2)= p2(1:n1,1:n2)+real(ip2)


         ! p0(1:n1,1:n2) = wt*vwt*p1(1:n1,1:n2)
         ! do ix=1,n2
         !   do iz=1,bc1
         !     p2(iz,ix) = p2(iz,ix) - p0(iz,ix)
         !     p2(iz+1,ix) = p2(iz+1,ix) + p0(iz,ix)    
         !   end do
          !  do iz=n1-bc3+1,n1
           !   p2(iz,ix) = p2(iz,ix) - p0(iz,ix)
           !   p2(iz-1,ix) = p2(iz-1,ix) + p0(iz,ix)
           ! end do
          !end do
          !do ix=1,bc2
           ! do iz=1,n1
           !   p2(iz,ix) = p2(iz,ix) - p0(iz,ix)
           !   p2(iz,ix+1) = p2(iz,ix+1) + p0(iz,ix)
           ! end do
          !end do
          !do ix=n2-bc4+1,n2
          !  do iz=1,n1
          !    p2(iz,ix) = p2(iz,ix) - p0(iz,ix)
          !    p2(iz,ix-1) = p2(iz,ix-1) + p0(iz,ix)
          !  end do
          !end do


          model(:,:,it) = model(:,:,it) + lwt1(iw)*p2(1:n1,1:n2)
          model(:,:,it-1) = model(:,:,it-1) + lwt2(iw)*p2(1:n1,1:n2)
          p0 = p1
          p1 = p2
        end do
      end do
      end if
    else
      write(0,*) "ip0 in the forward",sum(ip0)/size(ip0)
      ip0=0.0
      if (qcomp) then !!! qcomp
	write(0,*) "qcomp in the forward"
	write(0,*) "eta, tau,gama, gama_mean",sum(eta)/size(eta), sum(tau)/size(tau),sum(gama)/size(gama),gama_mean
	write(0,*) "oper_D, oper_L, oper_H",sum(oper_D)/size(oper_D), sum(oper_L)/size(oper_L),sum(oper_H)/size(oper_H)

      call sfftw_dft_2dx_init(plan_2d1F, ip1, n1, n2, +1)
      call sfftw_dft_2dx_init(plan_2dFDI, p1_FD, n1, n2, -1)
      call sfftw_dft_2dx_init(plan_2dFNDI, p1_FND, n1, n2, -1)
      call sfftw_dft_2dx_init(plan_2dFNHI, p1_FNH, n1, n2, -1)
      call sfftw_dft_2dx_init(plan_2dFNLI, p1_FNL, n1, n2, -1)
      if(.not. add) data = 0.
      do it=1,nt-1
        do iw=1,wfld_j
        !!! Yi :compute the part without spatial derivative 
     	!1) derivative in k domain

          ip1=p1(1:n1, 1:n2); !ip0=p0(1:n1,1:n2)
	  call sfftw_dft_2dx_oper(plan_2d1F, ip1, n1, n2)
	  p1_FD =oper_D*ip1
	  p1_FND =oper_D*ip1
	  p1_FNH =-(oper_H*ip1-oper_H*ip0)
	  p1_FNL =oper_L*ip1	

	!2) Apply high bandpass filter: filt(p1_FH); filt(p1_FL);  filt(p0_FH)
            	do iz=1,n1
	 	  call hammingw1(p1_FND(iz,:), pw3, pw4)
		  call hammingw1(p1_FNH(iz,:), pw3, pw4)
		  call hammingw1(p1_FNL(iz,:), pw3, pw4)
		end do	
		do ix=1, n2
		  call hammingw1(p1_FND(:,ix),  pw1, pw2)
		  call hammingw1(p1_FNH(:,ix),  pw1, pw2)
		  call hammingw1(p1_FNL(:,ix),  pw1, pw2)
		end do
	
 	!3) Derivative back to space domain

	  call sfftw_dft_2dx_oper(plan_2dFDI, p1_FD, n1, n2)
	  call sfftw_dft_2dx_oper(plan_2dFNDI, p1_FND, n1, n2)
	  call sfftw_dft_2dx_oper(plan_2dFNHI, p1_FNH, n1, n2)
	  call sfftw_dft_2dx_oper(plan_2dFNLI, p1_FNL, n1, n2)
	
	!4) Multiply coef

	  p2(1:n1, 1:n2)=lwt3(iw)*model(:,:,it) + lwt4(iw)*model(:,:,it+1) + (2.-wt)*p1(1:n1, 1:n2) + (wt-1.)*p0(1:n1, 1:n2)+real(veldt2*(1-wt)*p1_FD+veldt2*(1-wt)*(eta*p1_FNL-p1_FND)+vel2dt*(1-wt)*tau*p1_FNH)
	!5) Boundary condition
          do ix=1,n2
            do iz=1,bc1
              p2(iz,ix) = p2(iz,ix) - wt(iz,ix)*vwt(iz,ix)*(p1(iz,ix)-p1(iz+1,ix))
            end do
            do iz=n1-bc3+1,n1
              p2(iz,ix) = p2(iz,ix) - wt(iz,ix)*vwt(iz,ix)*(p1(iz,ix)-p1(iz-1,ix))
            end do
          end do
          do ix=1,bc2
            do iz=1,n1
              p2(iz,ix) = p2(iz,ix) - wt(iz,ix)*vwt(iz,ix)*(p1(iz,ix)-p1(iz,ix+1))
            end do
          end do
          do ix=n2-bc4+1,n2
            do iz=1,n1
              p2(iz,ix) = p2(iz,ix) - wt(iz,ix)*vwt(iz,ix)*(p1(iz,ix)-p1(iz,ix-1))
            end do
          end do
 
          data(:,:,it) = data(:,:,it) + lwt1(iw)*p2(1:n1, 1:n2)
          data(:,:,it+1) = data(:,:,it+1) + lwt2(iw)*p2(1:n1, 1:n2)

          p0 = p1
          p1 = p2
	  ip0 = ip1

        end do
      end do
	write(0,*) "p2", sum(p2)/size(p2)
      else !!! not qcomp
      write(0,*) "no qcomp in forward"
	write(0,*) "oper_D, oper_L, oper_H",sum(oper_D)/size(oper_D), sum(oper_L)/size(oper_L),sum(oper_H)/size(oper_H)
	write(0,*) "eta, tau,gama, gama_mean",sum(eta)/size(eta), sum(tau)/size(tau),sum(gama)/size(gama),gama_mean
      call sfftw_dft_2dx_init(plan_2d1F, ip1, n1, n2, +1)
      call sfftw_dft_2dx_init(plan_2dFNHI, p1_FNH, n1, n2, -1)
      call sfftw_dft_2dx_init(plan_2dFNLI, p1_FNL, n1, n2, -1)
      if(.not. add) data = 0.
      do it=1,nt-1
        do iw=1,wfld_j
        !!! Yi :compute the part without spatial derivative 
     	!1) derivative in k domain

          ip1=p1(1:n1, 1:n2); !ip0=p0(1:n1,1:n2)
	  call sfftw_dft_2dx_oper(plan_2d1F, ip1, n1, n2)
	  p1_FNH =oper_H*ip1-oper_H*ip0
	  p1_FNL =oper_L*ip1	

	  call sfftw_dft_2dx_oper(plan_2dFNHI, p1_FNH, n1, n2)
	  call sfftw_dft_2dx_oper(plan_2dFNLI, p1_FNL, n1, n2)
	
	!4) Multiply coef

	  p2(1:n1, 1:n2)=lwt3(iw)*model(:,:,it) + lwt4(iw)*model(:,:,it+1) + (2.-wt)*p1(1:n1, 1:n2) + (wt-1.)*p0(1:n1, 1:n2)+real(veldt2*(1-wt)*(eta*p1_FNL)+vel2dt*(1-wt)*tau*p1_FNH)
	!5) Boundary condition
        !  do ix=1,n2
        !    do iz=1,bc1
        !      p2(iz,ix) = p2(iz,ix) - wt(iz,ix)*vwt(iz,ix)*(p1(iz,ix)-p1(iz+1,ix))
        !    end do
        !    do iz=n1-bc3+1,n1
        !      p2(iz,ix) = p2(iz,ix) - wt(iz,ix)*vwt(iz,ix)*(p1(iz,ix)-p1(iz-1,ix))
        !    end do
        !  end do
        !  do ix=1,bc2
        !    do iz=1,n1
        !      p2(iz,ix) = p2(iz,ix) - wt(iz,ix)*vwt(iz,ix)*(p1(iz,ix)-p1(iz,ix+1))
        !    end do
        !  end do
        !  do ix=n2-bc4+1,n2
        !    do iz=1,n1
        !      p2(iz,ix) = p2(iz,ix) - wt(iz,ix)*vwt(iz,ix)*(p1(iz,ix)-p1(iz,ix-1))
        !    end do
        !  end do
 
          data(:,:,it) = data(:,:,it) + lwt1(iw)*p2(1:n1, 1:n2)
          data(:,:,it+1) = data(:,:,it+1) + lwt2(iw)*p2(1:n1, 1:n2)

          p0 = p1
          p1 = p2
	  ip0 = ip1
        end do
      end do
      end if
    end if
  end subroutine

end module
