program test

  use sep
  use  base_fftwv3_mod
  use  prop_base

  implicit none

  integer:: n1, n2
  real, allocatable:: dat(:,:), ifft(:,:)
  complex, allocatable :: fft(:,:)
  integer*8       :: plan_2dF, plan_2dI

  call sep_init()
  call from_history("n1", n1)
  call from_history("n2", n2)

  allocate(dat(n1, n2), ifft(n1, n2), fft(n1, n2))
  call sep_read(dat)
  write(0,*) "dat", sum(dat)/size(dat), n1, n2
  call sfftw_dft_2dx_init(plan_2dF, fft, n1, n2, +1)
  call sfftw_dft_2dx_init(plan_2dI, fft, n1, n2, -1)
  fft=dat
  call sfftw_dft_2dx_oper(plan_2dF, fft, n1, n2)
  call hammingw1(fft(:,1), 0.0, 0.0, 0.90, 1.0)
  !write(0,*) "fft", sum(fft)/size(fft)
  !call sfftw_dft_2dx_oper(plan_2dI, fft, n1, n2)
  !write(0,*) "ifft", sum(fft)/size(fft)
  ifft=abs(fft)
  call sep_write(ifft)
  deallocate(dat, ifft, fft)
end program
